      subroutine barotp(m,n,mm,nn,k1m,k1n)
c
c --- version 2.6
      implicit none
c
      include 'dimensions.h'
      include 'common_blocks.h'
c
      real q,utndcy,vtndcy
      integer lll,ml,nl,mn,ll,kan
c
      do 12 j=1,jj1
      do 12 k=1,kk
      do 12 l=1,isp(j)
      do 12 i=ifp(j,l),ilp(j,l)
 12   p(i,j,k+1)=p(i,j,k)+dp(i,j,k+nn)
c
c --- compute new -dpu,dpv- field. save old -dpu,dpv- values in -pu,pv-.
c
      do 14 j=1,jj1
c
      do 13 l=1,isu(j)
      do 13 k=1,kk
      kn=k+nn
      do 13 i=ifu(j,l),ilu(j,l)
 13   pu(i,j,k+1)=dpu(i,j,kn)
c
      do 14 l=1,isv(j)
      do 14 k=1,kk
      kn=k+nn
      do 14 i=ifv(j,l),ilv(j,l)
 14   pv(i,j,k+1)=dpv(i,j,kn)
c
      call dpudpv(p,depthu,depthv,dpu(1,1,1+nn),dpv(1,1,1+nn))
c
c --- substitute depth-weighted averages for (u,v) at massless grid points.
c --- (scan layers in top-down direction to save time.)
c --- extract barotropic velocities generated during most recent baroclinic
c --- time step and use them to force barotropic flow field.
c
      do 30 j=1,jj1
c
      do 31 l=1,isu(j)
c
      do 32 i=ifu(j,l),ilu(j,l)
 32   utotn(i,j)=0.
      do 33 k=1,kk
      km=k+mm
      kn=k+nn
      kan=max(1,k-1)+nn
      do 33 i=ifu(j,l),ilu(j,l)
      q=min(dpu(i,j,km),dpu(i,j,kn),onem)
      u(i,j,kn)=(u(i,j,kn)*q+u(i,j,kan)*(onem-q))/onem
 33   utotn(i,j)=utotn(i,j)+u(i,j,kn)*dpu(i,j,kn)
      do 31 i=ifu(j,l),ilu(j,l)
 31   utotn(i,j)=utotn(i,j)/depthu(i,j)
c
      do 30 l=1,isv(j)
c
      do 34 i=ifv(j,l),ilv(j,l)
 34   vtotn(i,j)=0.
      do 35 k=1,kk
      km=k+mm
      kn=k+nn
      kan=max(1,k-1)+nn
      do 35 i=ifv(j,l),ilv(j,l)
      q=min(dpv(i,j,km),dpv(i,j,kn),onem)
      v(i,j,kn)=(v(i,j,kn)*q+v(i,j,kan)*(onem-q))/onem
 35   vtotn(i,j)=vtotn(i,j)+v(i,j,kn)*dpv(i,j,kn)
      do 30 i=ifv(j,l),ilv(j,l)
 30   vtotn(i,j)=vtotn(i,j)/depthv(i,j)
c
c --- time smoothing of -u,v- fields
c
      do 22 k=1,kk
      km=k+mm
      kn=k+nn
c
      do 22 j=1,jj1
c
      do 24 l=1,isu(j)
      do 24 i=ifu(j,l),ilu(j,l)
      u(i,j,kn)=u(i,j,kn)-utotn(i,j)
ccc      u(i,j,km)=u(i,j,km)*wuv1+(uold(i,j,k)+u(i,j,kn))*wuv2
 24   u(i,j,km)=(u(i,j,km)*(wuv1*dpu(i,j,km)+onemm)
     .   +wuv2*(uold(i,j,k)*pu(i,j,k+1)+u(i,j,kn)*dpu(i,j,kn)))/
     .   (wuv1*dpu(i,j,km)+onemm+wuv2*(pu(i,j,k+1)+dpu(i,j,kn)))
c
      do 22 l=1,isv(j)
      do 22 i=ifv(j,l),ilv(j,l)
      v(i,j,kn)=v(i,j,kn)-vtotn(i,j)
ccc      v(i,j,km)=v(i,j,km)*wuv1+(vold(i,j,k)+v(i,j,kn))*wuv2
 22   v(i,j,km)=(v(i,j,km)*(wuv1*dpv(i,j,km)+onemm)
     .   +wuv2*(vold(i,j,k)*pv(i,j,k+1)+v(i,j,kn)*dpv(i,j,kn)))/
     .   (wuv1*dpv(i,j,km)+onemm+wuv2*(pv(i,j,k+1)+dpv(i,j,kn)))
c
c --- ------------------------------------------------------------------------
c --- advance barotropic equations from baroclinic time level -m- to level -n-
c --- ------------------------------------------------------------------------
c
      do 867 j=1,jj1
c
      do 865 l=1,isu(j)
      do 865 i=ifu(j,l),ilu(j,l)
      utotn(i,j)=utotn(i,j)/delt1
 865  ubavg(i,j,n)=ubavg(i,j,m)
c
      do 866 l=1,isv(j)
      do 866 i=ifv(j,l),ilv(j,l)
      vtotn(i,j)=vtotn(i,j)/delt1
 866  vbavg(i,j,n)=vbavg(i,j,m)
c
      do 867 l=1,isp(j)
      do 867 i=ifp(j,l),ilp(j,l)
 867  pbavg(i,j,n)=pbavg(i,j,m)
c
      ml=n
      nl=3
c
c --- explicit time integration of barotropic flow (forward-backward scheme)
c --- in order to combine forward-backward scheme with leapfrog treatment of
c --- coriolis term, v-eqn must be solved before u-eqn every other time step
      vthenu=.false.
c
      do 840 lll=1,lstep
c
c --- continuity equation
c
      do 843 j=1,jj1
      do 843 l=1,isp(j)
      do 843 i=ifp(j,l),ilp(j,l)
c --- use light time smoother in continuity equation
 843  pbavg(i,j,nl)=(1.-wbaro)*pbavg(i,j,ml)+wbaro*pbavg(i,j,nl)
     . -(1.+wbaro)*dlt*(ubavg(i+1,j,ml)*depthu(i+1,j)*scu(i+1)
     .                 -ubavg(i  ,j,ml)*depthu(i  ,j)*scu(i  )
     .                 +vbavg(i,j+1,ml)*depthv(i,j+1)*scv(i  )
     .                 -vbavg(i,j  ,ml)*depthv(i,j  )*scv(i  ))*scp2i(i)
c
      mn=ml
      if (vthenu) go to 901
c
c --- u momentum equation
c
 900  continue
c
      do 841 j=1,jj1
      do 841 l=1,isu(j)
      do 841 i=ifu(j,l),ilu(j,l)
      utndcy=-thref*(pbavg(i,j,nl)-pbavg(i-1,j,nl))*scui(i)
     .+(vbavg(i  ,j,mn)*depthv(i  ,j)+vbavg(i  ,j+1,mn)*depthv(i  ,j+1)
     . +vbavg(i-1,j,mn)*depthv(i-1,j)+vbavg(i-1,j+1,mn)*depthv(i-1,j+1))
     . *(pvtrop(i,j)+pvtrop(i,j+1))*.125
 841  ubavg(i,j,nl)=(1.-wbaro)*ubavg(i,j,ml)+wbaro*ubavg(i,j,nl)
     . +(1.+wbaro)*dlt*(utndcy+utotn(i,j))
c
      mn=nl
      if (vthenu) go to 902
c
c --- v momentum equation
c
 901  continue
c
      do 842 i=1,ii1
      do 842 l=1,jsv(i)
      do 842 j=jfv(i,l),jlv(i,l)
      vtndcy=-thref*(pbavg(i,j,nl)-pbavg(i,j-1,nl))*scvi(i)
     .-(ubavg(i,j  ,mn)*depthu(i,j  )+ubavg(i+1,j  ,mn)*depthu(i+1,j  )
     . +ubavg(i,j-1,mn)*depthu(i,j-1)+ubavg(i+1,j-1,mn)*depthu(i+1,j-1))
     . *(pvtrop(i,j)+pvtrop(i+1,j))*.125
 842  vbavg(i,j,nl)=(1.-wbaro)*vbavg(i,j,ml)+wbaro*vbavg(i,j,nl)
     . +(1.+wbaro)*dlt*(vtndcy+vtotn(i,j))
c
      mn=nl
      if (vthenu) go to 900
c
c --- switch order in which -u,v- equations are solved
 902  vthenu=.not.vthenu
c
      ll=ml
      ml=nl
      nl=ll
c
 840  continue
c
      return
      end
