      subroutine cnuity(m,n,mm,nn,k1m,k1n)
c
c --- version 2.6
      implicit none
c
      include 'dimensions.h'
      include 'common_blocks.h'
c
      common/linepr/lp
c
      integer lp
      real q,dpmin,clip,flxhi,flxlo,dtinv
c
c --- ------------------------------------------------------
c --- continuity equation (flux-corrected transport version)
c --- ------------------------------------------------------
c
      do 41 j=1,jj1
c
      do 74 l=1,isp(j)
      do 74 i=ifp(j,l),ilp(j,l)
 74   util3(i,j)=0.
c
      do 40 l=1,isu(j)
      do 40 i=ifu(j,l),ilu(j,l)
 40   utotn(i,j)=0.
c
      do 41 l=1,isv(j)
      do 41 i=ifv(j,l),ilv(j,l)
 41   vtotn(i,j)=0.
c
      do 76 k=1,kk
      km=k+mm
      kn=k+nn
c
c --- compute low-order (diffusive) fluxes at old time level.
c
      do 12 j=1,jj1
c
      do 11 l=1,isu(j)
      do 11 i=ifu(j,l),ilu(j,l)
      utotm(i,j)=(u(i,j,km)+ubavg(i,j,m))*scu(i)
      if (utotm(i,j).ge.0.) then
        q=min(dp(i-1,j,kn),max(0.,depthu(i,j)-util3(i-1,j)))
      else
        q=min(dp(i  ,j,kn),max(0.,depthu(i,j)-util3(i  ,j)))
      end if
 11   uflux(i,j)=utotm(i,j)*q
c
      do 12 l=1,isv(j)
      do 12 i=ifv(j,l),ilv(j,l)
      vtotm(i,j)=(v(i,j,km)+vbavg(i,j,m))*scv(i)
      if (vtotm(i,j).ge.0.) then
        q=min(dp(i,j-1,kn),max(0.,depthv(i,j)-util3(i,j-1)))
      else
        q=min(dp(i,j  ,kn),max(0.,depthv(i,j)-util3(i,j  )))
      end if
 12   vflux(i,j)=vtotm(i,j)*q
c
c --- advance -dp- field using low-order (diffusive) flux values
c
      dpmin=999.
c
      do 19 j=1,jj1
      do 19 l=1,isp(j)
      do 19 i=ifp(j,l),ilp(j,l)
      dpold(i,j,k)=dp(i,j,kn)
      util3(i,j)=util3(i,j)+dp(i,j,kn)
      dp(i,j,kn)=dp(i,j,kn)-(uflux(i+1,j)-uflux(i,j)
     .                      +vflux(i,j+1)-vflux(i,j))*delt1*scp2i(i)
 19   dpmin=min(dpmin,dp(i,j,kn))
c
      if (dpmin.lt.-onecm) then
      do 190 j=1,jj1
      do 190 l=1,isp(j)
      do 190 i=ifp(j,l),ilp(j,l)
      if (dp(i,j,kn).eq.dpmin)
     . write (lp,'(i9,'' i,j,k='',3i4,'' neg. dp (m) in loop 19'',
     . f9.2)') nstep,i,j,k,dpmin/onem
 190  continue
      end if
c
c --- compute 'antidiffusive' fluxes
c
c --- define antidiffusive fluxes as high-order minus low-order
c --- fluxes. high-order fluxes are second-order in space, time-centered.
c
      do 21 j=1,jj1
c
      do 20 l=1,isu(j)
      do 20 i=ifu(j,l),ilu(j,l)
      uflx(i,j,k)=uflux(i,j)
 20   uflux(i,j)=utotm(i,j)*dpu(i,j,km)-uflux(i,j)
c
      do 21 l=1,isv(j)
      do 21 i=ifv(j,l),ilv(j,l)
      vflx(i,j,k)=vflux(i,j)
 21   vflux(i,j)=vtotm(i,j)*dpv(i,j,km)-vflux(i,j)
c
c --- at each grid point, determine the ratio of the largest permissible
c --- pos. (neg.) change in -dp- to the sum of all incoming (outgoing) fluxes
c
      do 25 i=1,ii1
      do 25 l=1,jsp(i)
      do 25 j=jfp(i,l),jlp(i,l)
      ja=max(jfp(i,l),j-1)
      jb=min(jlp(i,l),j+1)
      util1(i,j)=max(dp(i,j,kn),dp(i,ja,kn),dp(i,jb,kn))
 25   util2(i,j)=min(dp(i,j,kn),dp(i,ja,kn),dp(i,jb,kn))
c
      do 27 j=1,jj1
      do 27 l=1,isp(j)
      do 27 i=ifp(j,l),ilp(j,l)
      ia=max(ifp(j,l),i-1)
      ib=min(ilp(j,l),i+1)
c
      util1(i,j)=max(util1(i,j),dp(ia,j,kn),dp(ib,j,kn))
      util2(i,j)=max(0.,
     .           min(util2(i,j),dp(ia,j,kn),dp(ib,j,kn)))
c
      util1(i,j)=(util1(i,j)-dp(i,j,kn))
     ./((max(0.,uflux(i,j))-min(0.,uflux(i+1,j))
     .  +max(0.,vflux(i,j))-min(0.,vflux(i,j+1))+epsil)
     .*delt1*scp2i(i))
c
 27   util2(i,j)=(util2(i,j)-dp(i,j,kn))
     ./((min(0.,uflux(i,j))-max(0.,uflux(i+1,j))
     .  +min(0.,vflux(i,j))-max(0.,vflux(i,j+1))-epsil)
     .*delt1*scp2i(i))
c
c --- limit antidiffusive fluxes
c --- (keep track in -utotn,vtotn- of discrepancy between high-order
c --- fluxes and the sum of low-order and clipped antidiffusive fluxes.
c --- this will be used later to restore nondivergence of barotropic flow)
c
      do 29 j=1,jj1
c
      do 28 l=1,isu(j)
      do 28 i=ifu(j,l),ilu(j,l)
      if (uflux(i,j).ge.0.) then
        clip=min(1.,util1(i,j),util2(i-1,j))
      else
        clip=min(1.,util2(i,j),util1(i-1,j))
      end if
      utotn(i,j)=utotn(i,j)+uflux(i,j)*(1.-clip)
      uflux(i,j)=uflux(i,j)*clip
 28   uflx(i,j,k)=uflx(i,j,k)+uflux(i,j)
c
      do 29 l=1,isv(j)
      do 29 i=ifv(j,l),ilv(j,l)
      if (vflux(i,j).ge.0.) then
        clip=min(1.,util1(i,j),util2(i,j-1))
      else
        clip=min(1.,util2(i,j),util1(i,j-1))
      end if
      vtotn(i,j)=vtotn(i,j)+vflux(i,j)*(1.-clip)
      vflux(i,j)=vflux(i,j)*clip
 29   vflx(i,j,k)=vflx(i,j,k)+vflux(i,j)
c
c --- evaluate effect of antidiffusive fluxes on -dp- field
c
      dpmin=999.
c
      do 1 j=1,jj1
      do 1 l=1,isp(j)
      do 1 i=ifp(j,l),ilp(j,l)
      dp(i,j,kn)=dp(i,j,kn)-(uflux(i+1,j)-uflux(i,j)
     .                      +vflux(i,j+1)-vflux(i,j))*delt1*scp2i(i)
      p(i,j,k+1)=p(i,j,k)+dp(i,j,kn)
 1    dpmin=min(dpmin,dp(i,j,kn))
c
      if (dpmin.lt.-onecm) then
      do 3 j=1,jj1
      do 3 l=1,isp(j)
      do 3 i=ifp(j,l),ilp(j,l)
      if (dp(i,j,kn).eq.dpmin)
     . write (lp,'(i9,'' i,j,k='',3i4,'' neg. dp (m) in loop  1'',
     . f9.2)') nstep,i,j,k,dpmin/onem
 3    continue
      end if
c
 76   continue
c
c --- restore nondivergence of vertically integrated mass flow by
c --- recovering fluxes lost in the flux limiting process.
c --- treat these fluxes as an 'upstream' barotropic correction to
c --- the sum of diffusive and antidiffusive fluxes obtained so far.
c
      do 77 k=1,kk
      km=k+mm
      kn=k+nn
c
      do 45 j=1,jj1
c
      do 44 l=1,isu(j)
      do 44 i=ifu(j,l),ilu(j,l)
      if (utotn(i,j).ge.0.) then
        q=dp(i-1,j,kn)/p(i-1,j,kk+1)
      else
        q=dp(i  ,j,kn)/p(i  ,j,kk+1)
      end if
      uflux(i,j)=utotn(i,j)*q
 44   uflx(i,j,k)=uflx(i,j,k)+uflux(i,j)
c
      do 45 l=1,isv(j)
      do 45 i=ifv(j,l),ilv(j,l)
      if (vtotn(i,j).ge.0.) then
        q=dp(i,j-1,kn)/p(i,j-1,kk+1)
      else
        q=dp(i,j  ,kn)/p(i,j  ,kk+1)
      end if
      vflux(i,j)=vtotn(i,j)*q
 45   vflx(i,j,k)=vflx(i,j,k)+vflux(i,j)
c
      dpmin=999.
c
      do 14 j=1,jj1
      do 14 l=1,isp(j)
      do 14 i=ifp(j,l),ilp(j,l)
      dp(i,j,kn)=dp(i,j,kn)-(uflux(i+1,j)-uflux(i,j)
     .                      +vflux(i,j+1)-vflux(i,j))*delt1*scp2i(i)
      p(i,j,k+1)=p(i,j,k)+dp(i,j,kn)
 14   dpmin=min(dpmin,dp(i,j,kn))
c
      if (dpmin.lt.-onecm) then
      do 140 j=1,jj1
      do 140 l=1,isp(j)
      do 140 i=ifp(j,l),ilp(j,l)
      if (dp(i,j,kn).gt.dpmin) go to 140
      write (lp,'(i9,'' i,j,k='',3i4,'' neg. dp (m) in loop 14'',
     . f9.2)') nstep,i,j,k,dpmin/onem
 140  continue
      end if
c
 77   continue
c
c --- add bottom-pressure restoring term arising from split-explicit treatment
c --- of continuity equation (step 4 in appendix b to 1992 brhs paper)
c
      do 39 j=1,jj1
      do 39 l=1,isp(j)
      do 39 k=1,kk
      kn=k+nn
      do 39 i=ifp(j,l),ilp(j,l)
      dp(i,j,kn)=dp(i,j,kn)*pbot(i,j)/p(i,j,kk+1)
 39   p(i,j,k+1)=p(i,j,k)+dp(i,j,kn)
c
c --- ----------------------------------------------------------
c --- thickness diffusion (literally, interface depth diffusion)
c --- ----------------------------------------------------------
c
      if (thkdff.eq.0.) return
      dtinv=1./delt1
c
      do 816 k=2,kk
      kn=k+nn
c
      do 818 j=1,jj1
c
      do 817 l=1,isu(j)
      do 817 i=ifu(j,l),ilu(j,l)
      flxhi= .25*(p(i  ,j,kk+1)-p(i  ,j,k))*scp2(i  )
      flxlo=-.25*(p(i-1,j,kk+1)-p(i-1,j,k))*scp2(i-1)
      uflux(i,j)=min(flxhi,max(flxlo,
     .           thkdff*delt1*(p(i-1,j,k)-p(i,j,k))*scu(i)))
      uflx(i,j,k-1)=uflx(i,j,k-1)+uflux(i,j)*dtinv
      uflx(i,j,k  )=uflx(i,j,k  )-uflux(i,j)*dtinv
 817  continue
c
      do 818 l=1,isv(j)
      do 818 i=ifv(j,l),ilv(j,l)
      flxhi= .25*(p(i,j  ,kk+1)-p(i,j  ,k))*scp2(i  )
      flxlo=-.25*(p(i,j-1,kk+1)-p(i,j-1,k))*scp2(i  )
      vflux(i,j)=min(flxhi,max(flxlo,
     .           thkdff*delt1*(p(i,j-1,k)-p(i,j,k))*scv(i)))
      vflx(i,j,k-1)=vflx(i,j,k-1)+vflux(i,j)*dtinv
      vflx(i,j,k  )=vflx(i,j,k  )-vflux(i,j)*dtinv
 818  continue
c
      do 816 j=1,jj1
      do 816 l=1,isp(j)
      do 816 i=ifp(j,l),ilp(j,l)
c
cdiag if (i.eq.itest.and.j.eq.jtest)
cdiag.write (lp,'(i9,3i4,'' intfc.depth diffusion -- p_old, d_p ='',
cdiag.f9.2,f8.4)') nstep,itest,jtest,k,p(itest,jtest,k)/onem,-delt1*
cdiag.(uflux(itest+1,jtest)-uflux(itest,jtest)+vflux(itest,jtest+1)-
cdiag.vflux(itest,jtest))/(scp2(itest)*onem)
c
      p(i,j,k)=p(i,j,k)-(uflux(i+1,j)-uflux(i,j)
     .                  +vflux(i,j+1)-vflux(i,j))*scp2i(i)
 816  dp(i,j,kn-1)=p(i,j,k)-p(i,j,k-1)
c
      do 819 j=1,jj1
      do 819 l=1,isp(j)
      do 819 i=ifp(j,l),ilp(j,l)
 819  dp(i,j,kk+nn)=p(i,j,kk+1)-p(i,j,kk)
c
      return
      end
