c -------------------------------------------------------------------------
      c o m m o n
     . u(idm,jdm,2*kdm),uold(idm,jdm,kdm)     ! u velocity component
     .,v(idm,jdm,2*kdm),vold(idm,jdm,kdm)     ! v velocity component
     .,dp(idm,jdm,2*kdm),dpold(idm,jdm,kdm)   ! layer thickness
     .,dpu(idm,jdm,2*kdm),dpv(idm,jdm,2*kdm)  ! layer thickness at u,v points
     .,p(idm,jdm,kdm+1)                       ! interface pressure
     .,pu(idm,jdm,kdm+1),pv(idm,jdm,kdm+1)    ! interface pres. at u,v points
     .,corio(idm,jdm)                         ! coriolis parameter
     .,psikk(idm,jdm)                         ! montg.pot. in bottom layer
     .,vort(idm,jdm),potvor(idm,jdm)          ! vorticity, potential vorticity
     .,thmix(idm,jdm,2)                       ! mixed layer density
     .,temp(idm,jdm,2*kdm)                    ! temperature
     .,saln(idm,jdm,2*kdm)                    ! salinity
     .,sdot(idm,jdm)                          ! generalized vert. velocity
c
      real u,uold,v,vold,dp,dpold,dpu,dpv,p,pu,pv,corio,psikk,vort,
     .     potvor,thmix,temp,saln,sdot
c
      c o m m o n
     . montg(idm,jdm,kdm)                     ! montgomery potential
     .,defor1(idm,jdm),defor2(idm,jdm)        ! deformation components
     .,ubavg(idm,jdm,3),vbavg(idm,jdm,3)      ! barotropic velocity
     .,pbavg(idm,jdm,3)                       ! barotropic pressure
     .,ubrhs(idm,jdm),vbrhs(idm,jdm)          ! rhs of barotropic u,v eqns.
     .,utotm(idm,jdm),vtotm(idm,jdm)          ! total (barotrop.+baroclin.)..
     .,utotn(idm,jdm),vtotn(idm,jdm)          ! ..velocities at 2 time levels
     .,uflux(idm,jdm),vflux(idm,jdm)          ! horizontal mass fluxes
     .,uflux1(idm,jdm),vflux1(idm,jdm)        ! more mass fluxes
     .,uflux2(idm,jdm),vflux2(idm,jdm)        ! more mass fluxes
     .,uflux3(idm,jdm),vflux3(idm,jdm)        ! more mass fluxes
     .,uflx(idm,jdm,kdm),vflx(idm,jdm,kdm)    ! more mass fluxes
c
      real montg,defor1,defor2,ubavg,vbavg,pbavg,ubrhs,vbrhs,utotm,
     .     vtotm,utotn,vtotn,uflux,vflux,uflux1,vflux1,uflux2,vflux2,
     .     uflux3,vflux3,uflx,vflx
c
      c o m m o n
     . util1(idm,jdm),util2(idm,jdm)          ! arrays for temporary storage
     .,util3(idm,jdm),util4(idm,jdm)          ! arrays for temporary storage
     .,scu(idm),scv(idm),scp(idm)             ! grid scale at u,v,p points
     .,scu2(idm),scv2(idm),scp2(idm)          ! grid scales squared
     .,scui(idm),scvi(idm),scpi(idm)          ! inverses of scu,scv,scp
     .,scu2i(idm),scv2i(idm),scp2i(idm)       ! inverses of scu2,scv2,scp2
     .,pgfx(idm,jdm),pgfy(idm,jdm)            ! horiz. presssure gradient
     .,gradx(idm,jdm),grady(idm,jdm)          ! horiz. presssure gradient
     .,depthu(idm,jdm),depthv(idm,jdm)        ! bottom pres. at u,v points
     .,pvtrop(idm,jdm)                        ! pot.vort. of barotropic flow
     .,depths(idm,jdm)                        ! water depth
     .,drag(idm,jdm)                          ! bottom drag
     .,visc(idm,jdm)                          ! eddy viscosity
c
      real util1,util2,util3,util4,scu,scui,scu2,scu2i,scv,scvi,scv2,
     .     scv2i,scp,scpi,scp2,scp2i,pgfx,pgfy,gradx,grady,depthu,
     .     depthv,pvtrop,depths,drag,visc
c
      c o m m o n
     . uja(idm,jdm),ujb(idm,jdm)              ! velocities at lateral
     .,via(idm,jdm),vib(idm,jdm)              !          neighbor points
     .,wgtia(idm,jdm),wgtib(idm,jdm)          ! submerged sidewall weights
     .,wgtja(idm,jdm),wgtjb(idm,jdm)          ! submerged sidewall weights
     .,pbot(idm,jdm)                          ! bottom pressure at t=0
     .,tracer(idm,jdm,kdm)                    ! inert tracer (optional)
     .,klist(idm,jdm)                         ! k-index of layer below mixl'r
     .,thup(idm,kdm),thdn(idm,kdm)            ! bulk theta above/below intfc
     .,sgain(idm,kdm)                         ! salin.changes from diapyc.mix.
     .,surflx(idm,jdm)                        ! surface thermal energy flux
     .,salflx(idm,jdm)                        ! surface salinity flux
     .,buoyfl(idm,jdm)                        ! surface buoyancy flux
     .,ustar(idm,jdm)                         ! friction velocity
     .,turgen(idm,jdm)                        ! turb.kin.energ. generation
     .,tdp(idm,jdm),sdp(idm,jdm)              ! depth-integrated t/s
c
      integer klist
      real uja,ujb,via,vib,wgtia,wgtib,wgtja,wgtjb,pbot,tracer,thup,
     .     thdn,sgain,surflx,salflx,buoyfl,ustar,turgen,tdp,sdp
c
c ---  s w i t c h e s    (if set to .true., then...)
c --- diagno      output model fields and diagnostic messages
c --- rotat       rotate poles in mercator projection by 90 deg.
c --- thermo      use thermodynamic forcing functions
c --- vthenu      (used in forward-backward time differencing scheme)
c --- trcrin      initialize tracer from restart file
c --- trcout      advect tracer and save results in history/restart file
c
      logical rotat,thermo,vthenu,diagno,trcrin,trcout,relax
      common/swtchs/rotat,thermo,vthenu,diagno,trcrin,trcout,relax
c
      c o m m o n  /frcing/                   !  monthly forcing fields
     . taux(idm,jdm,12)                       !  wind stress in x direction
     .,tauy(idm,jdm,12)                       !  wind stress in y direction
     .,wndspd(idm,jdm,12)                     !  wind speed (tke source)
     .,radflx(idm,jdm,12)                     !  short-wave radiation
     .,airtmp(idm,jdm,12)                     !  pseudo air temperature
     .,precip(idm,jdm,12)                     !  precipitation
     .,vapmix(idm,jdm,12)                     !  atmosph. vapor mixing ratio
     .,rmu(nbdy)                              !  weights for lateral b.c. relax.
     .,pwall(nbdy,jdm,kdm,12)                 !  pressure b.c. along sidewalls
     .,swall(nbdy,jdm,kdm, 4)                 !  salinity b.c. along sidewalls
     .,twall(nbdy,jdm,    12)                 !  mxlyr.temp. b.c. at sidewalls
c
      real taux,tauy,wndspd,radflx,airtmp,precip,vapmix,rmu,pwall,
     .     swall,twall
c
      common/varbls/time,delt1,dlt,
     .              w0,w1,w2,w3,area,watcum,empcum,
     .              ws0,ws1,ws2,ws3,
     .              nstep,nstep1,nstep2,l0,l1,l2,l3,
     .              lstep,ls0,ls1,ls2,ls3
c
      integer nstep,nstep1,nstep2,lstep,l0,l1,l2,l3,
     .        ls0,ls1,ls2,ls3
      real time,delt1,dlt,w0,w1,w2,w3,area,watcum,empcum,
     .     ws0,ws1,ws2,ws3
c
c --- specific volume in layer k is  alpha = 1/rho = thref x ( 1 - theta(k) )
c --- 'baclin' = baroclinic time step
c --- 'batrop' = barotropic time step
c --- 'thkdff' = diffusion velocity (cm/s) for thickness diffusion
c --- 'veldff' = diffusion velocity (cm/s) for momentum dissipation
c --- 'temdff' = diffusion velocity (cm/s) for temp/salin. mixing
c --- 'viscos' is nondimensional, used in deformation-dependent viscosity
c --- 'diapyc' = diapycnal diffusivity times buoyancy freq. (cm**2/s**2)
c --- 'vertmx' = diffusion velocity (cm/s) for mom.mixing across mix.layr.base
c --- 'mixfrq' = number of time steps between diapycnal mixing calculations
c --- 'h0'     = vertical averaging depth for diapycnic flux calculations
c --- 'h1'     = depth interval used in lateral weighting of hor.pres.grad.
c --- slip = +1  for free-slip boundary cond., slip = -1  for non-slip cond.
c --- 'cbar'   = rms flow speed (cm/s) for linear bottom friction law
c --- 'diagfq' = number of days between model diagnostics (incl.output)
c --- 'ntracr' = number of time steps between tracer transport
c --- 'wuv1/2' = weights for time smoothing of u,v field
c --- 'wts1/2' = weights for time smoothing of t,s field
c --- 'wbaro'  = weight for time smoothing of barotropic u,v,p field
c --- 'thkmin' = minimum mixed-layer thickness (m)
c --- 'thkbot' = thickness of bottom boundary layer (pressure units)
c
      common/parms1/theta(kdm),thbase,baclin,batrop,thkdff,veldff,
     .              temdff,viscos,diapyc,vertmx,h0,h1,slip,cbar,
     .              diagfq,wuv1,wuv2,wts1,wts2,wbaro,thkmin,
     .              thkbot,mixfrq,ntracr
c
      integer mixfrq,ntracr
      real theta,thbase,baclin,batrop,thkdff,veldff,temdff,viscos,
     .     diapyc,vertmx,h0,h1,slip,cbar,diagfq,wuv1,wuv2,wts1,wts2,
     .     wbaro,thkmin,thkbot,thiklo,thikhi
c
c --- 'tenm,onem,...' = pressure thickness values corresponding to 10m,1m,...
c --- 'g'      = gravity acceleration
c --- 'csubp'  = specific heat of air at constant pressure (j/g/deg)
c --- 'spcifh' = specific heat of sea water (j/g/deg)
c --- 'cd'     = drag coefficient
c --- 'ct'     = thermal transfer coefficient
c --- 'airdns' = air density at sea level (g/cm**3)
c --- 'evaplh' = latent heat of evaporation (j/g)
c --- 'thref'  = reference value of specific volume (cm**3/g)
c --- 'epsil'  = small nonzero number used to prevent division by zero
c
      common/consts/tenm,onem,tencm,onecm,onemm,g,csubp,spcifh,cd,ct,
     .              airdns,evaplh,thref,epsil,radian,pi
c
      real tenm,onem,tencm,onecm,onemm,g,csubp,spcifh,cd,ct,airdns,
     .     evaplh,thref,epsil,huge,radian,pi
c
c --- grid point where detailed diagnostics are desired:
      common/testpt/itest,jtest
c
      integer itest,jtest
c
c --- two   m a p   p r o j e c t i o n s   are supported:
c --- rotat = .false.: conventional mercator projection
c ---                  (i and x pointing south, j and y pointing east)
c --- rotat = .true.:  mercator projection with poles rotated +90 deg.
c ---                  (i and x pointing east, j and y pointing north)
c
c --- if rotat=.true., (xpivo,ypivo) and (xpivn,ypivn), respectively, mark
c --- the location of the intersection of the true and model equator ('pivot
c --- point') in the lat/lon and rotated model grid.
c --- if rotat=.false., xpivn specifies the i-index of the equator (xpivo,
c --- ypivo,ypivn not used).
c --- grido = mesh size of lat/lon grid in degrees
c --- gridn = mesh size of actual model grid (rotated or not) in deg. longitude
c
      common/pivot/xpivo,ypivo,grido,xpivn,ypivn,gridn
c
      real xpivo,ypivo,grido,xpivn,ypivn,gridn
c
c --- locations of lat/lon grid points and of associated x-coordinate
c --- direction as viewed in rotated model grid:
c
      common/newgrd/ xnew(nlato,nlongo), ynew(nlato,nlongo),
     .              dxnew(nlato,nlongo),dynew(nlato,nlongo)
c
      real xnew, ynew,dxnew,dynew
c
c --- locations of rotated model grid points and of associated x-coordinate 
c --- direction as viewed in lat/lon grid:
c
      common/oldgrd/ xold(nlatn,nlongn), yold(nlatn,nlongn),
     .              dxold(nlatn,nlongn),dyold(nlatn,nlongn)
c
      real xold,yold,dxold,dyold
c -------------------------------------------------------------------------
