      subroutine convec(m,n,mm,nn,k1m,k1n)
c
c --- version 2.6
      implicit none
c
      include 'dimensions.h'
      include 'common_blocks.h'
c
      real dthmin,dthet,delp
      integer kk1(idm)
c
      include 'stmt_functions.h'
c
c --- -------------------------------------------------------------
c --- entrain water lighter than mixed-layer water into mixed layer
c --- -------------------------------------------------------------
c
cmic$ do all  autoscope
      do 1 i=1,ii1
c
c --- for efficiency, choose outer loop to make -kk1- latitude-dependent
      kk1(i)=0
c
      do 2 l=1,jsp(i)
c
      do 9 j=jfp(i,l),jlp(i,l)
 9    dpold(i,j,1)=dp(i,j,k1n)
c
      do 2 k=2,kk
      do 2 j=jfp(i,l),jlp(i,l)
 2    dpold(i,j,k)=0.
c
      do 3 k=2,kk
      kn=k+nn
      dthmin=999.
c
      do 4 l=1,jsp(i)
      do 4 j=jfp(i,l),jlp(i,l)
      dthet=theta(k)-thmix(i,j,n)
      if (dthet.lt.0..and.dp(i,j,kn).gt.0.) then
c
c --- layer -k- contains mass less dense than mixed layer. entrain.
        delp=dp(i,j,k1n)+dp(i,j,kn)
        saln(i,j,k1n)=(saln(i,j,k1n)*dp(i,j,k1n)
     .                +saln(i,j,kn )*dp(i,j,kn ))/delp
        temp(i,j,k1n)=(temp(i,j,k1n)*dp(i,j,k1n)
     .                +temp(i,j,kn )*dp(i,j,kn ))/delp
        thmix(i,j,n)=sig(temp(i,j,k1n),saln(i,j,k1n))-thbase
c
c --- mass in layer -k- transferred to mixed layer is stored in -dpold-
        dp(i,j,k1n)=delp
        dpold(i,j,k)=dp(i,j,kn)
        dp(i,j,kn)=0.
      end if                 !  dthet < 0
c
 4    dthmin=min(dthmin,dthet)
c
      if (dthmin.ge.0.) go to 1
 3    kk1(i)=k
 1    continue
c
c --- entrain -u- momentum
c
      do 7 i=1,ii1
c
      do 5 l=1,jsu(i)
c
      do 6 j=jfu(i,l),jlu(i,l)
 6    util2(i,j)=min(.5*(dpold(i,j,1)+dpold(i-1,j,1)),depthu(i,j))
c
      do 5 k=2,max(kk1(i),kk1(i-1))
      kn=k+nn
      do 5 j=jfu(i,l),jlu(i,l)
      util1(i,j)=util2(i,j)
      util2(i,j)=min(util2(i,j)+
     .               .5*(dpold(i,j,k)+dpold(i-1,j,k)),depthu(i,j))
 5    u(i,j,k1n)=(u(i,j,k1n)*util1(i,j)
     .           +u(i,j,kn)*(util2(i,j)-util1(i,j)))/util2(i,j)
c
c --- entrain -v- momentum
c
      do 7 l=1,jsv(i)
c
      do 8 j=jfv(i,l),jlv(i,l)
 8    util2(i,j)=min(.5*(dpold(i,j,1)+dpold(i,j-1,1)),depthv(i,j))
c
      do 7 k=2,kk1(i)
      kn=k+nn
      do 7 j=jfv(i,l),jlv(i,l)
      util1(i,j)=util2(i,j)
      util2(i,j)=min(util2(i,j)+
     .               .5*(dpold(i,j,k)+dpold(i,j-1,k)),depthv(i,j))
 7    v(i,j,k1n)=(v(i,j,k1n)*util1(i,j)
     .           +v(i,j,kn)*(util2(i,j)-util1(i,j)))/util2(i,j)
c
      do 66 j=1,jj1
      do 66 k=1,kk
      do 66 l=1,isp(j)
      do 66 i=ifp(j,l),ilp(j,l)
 66   p(i,j,k+1)=p(i,j,k)+dp(i,j,k+nn)
c
      return
      end
