      subroutine diapfl(m,n,mm,nn,k1m,k1n)
c
c --- version 2.6
      implicit none
c
      include 'dimensions.h'
      include 'common_blocks.h'
c
      common/linepr/lp
c
      real hmod(idm,jdm),h0lo,h0hi,wgt,delp,thk,thka,thkb,pmid,p1,p2,
     .     dif,dthet,bound,thkn,saldp
      integer lp,mn,mmnn,ka,kb,kp,kpn
c
c --- ----------------
c --- diapycnal mixing
c --- ----------------
c
      if (diapyc.gt.0..and.mod(nstep,mixfrq).eq.0) then
c
c --- apply mixing algorithm to both time levels (first m, then n) in fwd mode
      do 30 mn=m,n,n-m
      mmnn=(mn-1)*kk
c
cmic$ do all  private(thup,thdn,sgain)  autoscope
      do 30 j=1,jj1
c
      do 18 l=1,isp(j)
c
      do 53 i=ifp(j,l),ilp(j,l)
      dpold(i,j, 1)=0.
      dpold(i,j,kk)=0.
      sgain(i,1)=saln(i,j,1+mmnn)*dp(i,j,1+mmnn)
 53   klist(i,j)=2
c
      do 531 k=1,kk
      do 531 i=ifp(j,l),ilp(j,l)
 531  p(i,j,k+1)=p(i,j,k)+dp(i,j,k+mmnn)
c
c --- integrate theta over various slabs of thickness -h0- and -hmod-
c --- thup/thdn(*,1): bulk theta above/below center of layer k (use hmod)
c --- thup/thdn(*,k): bulk theta above/below interface k (use h0)
c
      do 18 k=2,kk
      kn=k+mmnn
c
      do 17 i=ifp(j,l),ilp(j,l)
      sgain(i,k)=saln(i,j,kn)*dp(i,j,kn)
c --- store index of first isopycnic layer heavier than mix.layer in -klist-
      if (theta(k).lt.thmix(i,j,n)) klist(i,j)=min(k+1,kk)
c
c --- hmod increases from -h0lo- to -h0hi- over depth range -delp-
      delp=1000.*onem
      h0lo=min(   h0,.25*p(i,j,kk+1))
      h0hi=min(5.*h0,.25*p(i,j,kk+1))
      wgt=max(0.,min(1.,(delp-p(i,j,k-1))/delp))
      hmod(i,j)=h0lo*wgt+h0hi*(1.-wgt)
c
      thup(i,k)=epsil*max(thmix(i,j,mn),theta(k-1))
      thdn(i,k)=epsil*max(thmix(i,j,mn),theta(k  ))
      thup(i,1)=thdn(i,k)
      thdn(i,1)=thdn(i,k)
      util1(i,j)=epsil
      util2(i,j)=epsil
      util3(i,j)=epsil
 17   util4(i,j)=epsil
c
c --- find bulk theta value in slab of thickness -h0- above k-th interface
      do 61 kp=1,k-1
      do 61 i=ifp(j,l),ilp(j,l)
      delp=max(0.,min(p(i,j,k)   ,p(i,j,kp+1))
     .           -max(p(i,j,k)-h0,p(i,j,kp  )))
      thup(i,k)=thup(i,k)+max(thmix(i,j,mn),theta(kp))*delp
 61   util1(i,j)=util1(i,j)                           +delp
c
c --- find bulk theta value in slab of thickness -h0- below k-th interface
      do 51 kp=k,kk
      do 51 i=ifp(j,l),ilp(j,l)
      delp=max(0.,min(p(i,j,k)+h0,p(i,j,kp+1))
     .           -max(p(i,j,k)   ,p(i,j,kp  )))
      thdn(i,k)=thdn(i,k)+max(thmix(i,j,mn),theta(kp))*delp
 51   util2(i,j)=util2(i,j)                           +delp
c
      do 36 kp=1,kk
      ka=max(kp-1, 1)
      kb=min(kp+1,kk)
c
      do 36 i=ifp(j,l),ilp(j,l)
c
      thk= max(thmix(i,j,mn),theta(kp))
      thka=max(thmix(i,j,mn),theta(ka))
      thkb=max(thmix(i,j,mn),theta(kb))
      if (kp.eq.1)  thkb=   thk
      if (kp.eq.kk) thkb=2.*thk-thka
      thka=.5*(thk+thka)
      thkb=.5*(thk+thkb)
c
c --- find bulk theta value in slab of thickness -hmod- above k-th mass point
      pmid=.5*(p(i,j,k)+p(i,j,k+1))
      p1=max(pmid-hmod(i,j),p(i,j,kp  ))
      p2=min(pmid          ,p(i,j,kp+1))
      delp=max(0.,p2-p1)
      thup(i,1)=thup(i,1)+(thka*(p(i,j,kp+1)-.5*(p1+p2))
     .                    -thkb*(p(i,j,kp  )-.5*(p1+p2)))
     . /max(epsil,p(i,j,kp+1)-p(i,j,kp))*delp
      util3(i,j)=util3(i,j)             +delp
c
c --- find bulk theta value in slab of thickness -hmod- below k-th mass point
c --- (achieve thdn => thup near sea floor by elevating -pmid-)
      pmid=min(pmid,p(i,j,kk+1)-hmod(i,j))
      p1=max(pmid          ,p(i,j,kp  ))
      p2=min(pmid+hmod(i,j),p(i,j,kp+1))
      delp=max(0.,p2-p1)
      thdn(i,1)=thdn(i,1)+(thka*(p(i,j,kp+1)-.5*(p1+p2))
     .                    -thkb*(p(i,j,kp  )-.5*(p1+p2)))
     . /max(epsil,p(i,j,kp+1)-p(i,j,kp))*delp
 36   util4(i,j)=util4(i,j)             +delp
c
      do 18 i=ifp(j,l),ilp(j,l)
c
      thup(i,k)=             thup(i,k)/util1(i,j)
      thdn(i,k)=max(theta(k),thdn(i,k)/util2(i,j))
      thup(i,1)=thup(i,1)/util3(i,j)
      thdn(i,1)=thdn(i,1)/util4(i,j)
c
cdiag if (i.eq.itest.and.j.eq.jtest) write (lp,'(i9,3i4,'' th_hi/lo:'',
cdiag.3p2f9.3)') nstep,i,j,k,thup(i,1)+thbase,thdn(i,1)+thbase
c
c --- store turbulent buoyancy fluxes in -dpold- (positive = downward)
c
c --- use the following if exch.coeff. = diapyc/buoyancy frequency
      dpold(i,j,k)=diapyc*sqrt(max(0.,thdn(i,1)-thup(i,1))
     .   /(thref*hmod(i,j)))
c --- use the following if exch.coeff. = diapyc
ccc      dpold(i,j,k)=diapyc*g*max(0.,thdn(i,1)-thup(i,1))
ccc     .   /(thref*hmod(i,j))
 18   if (k.lt.klist(i,j)) dpold(i,j,k)=0.
c
cdiag if (j.eq.jtest) then
cdiag write (lp,'(i9,2i4,'' diapyc.flx:'',7x,1p10e9.2/(36x,10e9.2))')
cdiag.nstep,itest,jtest,(dpold(itest,jtest,k),k=2,kk-1)
cdiag write (lp,'(i9,2i4,'' th_up:'',6x,3p10f9.3/(31x,10f9.3))')
cdiag.nstep,itest,jtest,(thup(itest,k)+thbase,k=2,kk)
cdiag write (lp,'(i9,2i4,'' th_dn:'',6x,3p10f9.3/(31x,10f9.3))')
cdiag.nstep,itest,jtest,(thdn(itest,k)+thbase,k=2,kk)
cdiag write (lp,'(i9,2i4,'' old saln:'',11f9.4/(27x,10f9.4))')
cdiag.nstep,itest,jtest,(saln(itest,jtest,k+mmnn),k=1,kk)
cdiag end if
c
c --- now find the divergence of the buoyancy fluxes stored in -dpold-
c
      do 30 l=1,isp(j)
c
      do 60 k=kk,2,-1
      kn=k+mmnn
c
      do 58 i=ifp(j,l),ilp(j,l)
c
      dif=dpold(i,j,k-1)-dpold(i,j,k)
c --- util1/util2: upper/lower theta values used in calculating flux div.
      util1(i,j)=max(thmix(i,j,mn),theta(k-1))
      util2(i,j)=max(thmix(i,j,mn),theta(k  ))
      if (dif.lt.0.) then
        util1(i,j)=thup(i,k)
      else
        util2(i,j)=thdn(i,k)
      end if
      dthet=max(1.e-5*thref,util2(i,j)-util1(i,j))
c --- sdot = coordinate surface displacement caused by diapyc. flux.div.
      sdot(i,j)=baclin*mixfrq*onecm*dif/dthet
c
c --- interfaces must not descend below sea floor. adjust fluxes accordingly
      thkn=p(i,j,k+1)-p(i,j,k)
      if (thkn.ge.0.) then
        bound=p(i,j,kk+1)-p(i,j,k)
      else
        bound=thkn
      end if
      sdot(i,j)=min(bound,sdot(i,j))
c
c --- interface must not ascend above sea surface
      sdot(i,j)=max(-.9*p(i,j,k),sdot(i,j))
c
      if (k.gt.klist(i,j))
     .dpold(i,j,k-1)=dpold(i,j,k)+sdot(i,j)*dthet/(baclin*mixfrq*onecm)
c
cdiag if (i.eq.itest.and.j.eq.jtest)
cdiag.write (lp,'(i9,3i4,'' sdot:'',f9.2,'' mm     p at k,k+1 ='',2f9.3,
cdiag.5x,''flx,th at k-1,k:'',1p2e9.2,3p2f7.3)') nstep,i,j,k,sdot(i,j)
cdiag./onemm,p(i,j,k)/onem,p(i,j,k+1)/onem,dpold(i,j,k-1),dpold(i,j,k),
cdiag.util1(i,j)+thbase,util2(i,j)+thbase
c
 58   continue
c
c --- sdot < 0 -- extract mass (and salin.) from layers above k-th interface
      do 59 kp=1,k-1
      kpn=kp+mmnn
      do 59 i=ifp(j,l),ilp(j,l)
      delp=0.
      if (sdot(i,j).lt.0.)
     .delp=max(0.,min(p(i,j,k)   ,p(i,j,kp+1))
     .           -max(p(i,j,k)-h0,p(i,j,kp  )))*(-sdot(i,j))/h0
c
cdiag if (i.eq.itest.and.j.eq.jtest.and.delp.gt.0.)
cdiag.write (lp,'(i9,2i4,'' transfer'',f9.2,'' mm from layer'',i3,
cdiag.'' to'',i3)') nstep,i,j,delp/onemm,kp,k
c
      dp(i,j,kpn)=dp(i,j,kpn)-delp
      dp(i,j,kn )=dp(i,j,kn )+delp
      saldp=saln(i,j,kpn)*delp
      sgain(i,kp)=sgain(i,kp)-saldp
 59   sgain(i,k )=sgain(i,k )+saldp
c
c --- sdot > 0 -- extract mass (and salin.) from layers below k-th interface
      do 60 kp=k,kk
      kpn=kp+mmnn
      do 60 i=ifp(j,l),ilp(j,l)
      delp=0.
      if (sdot(i,j).ge.0.)
     .delp=max(0.,min(p(i,j,k)+h0,p(i,j,kp+1))
     .           -max(p(i,j,k)   ,p(i,j,kp  )))*  sdot(i,j)
     .     /max(epsil,min(p(i,j,kk+1)-p(i,j,k),h0))
c
cdiag if (i.eq.itest.and.j.eq.jtest.and.delp.gt.0.)
cdiag.write (lp,'(i9,2i4,'' transfer'',f9.2,'' mm from layer'',i3,
cdiag.'' to'',i3)') nstep,i,j,delp/onemm,kp,k-1
c
      dp(i,j,kpn )=dp(i,j,kpn )-delp
      dp(i,j,kn-1)=dp(i,j,kn-1)+delp
      saldp=saln(i,j,kpn)*delp
      sgain(i,kp )=sgain(i,kp )-saldp
 60   sgain(i,k-1)=sgain(i,k-1)+saldp
c
      do 78 k=1,kk
      kn=k+mmnn
c
      do 78 i=ifp(j,l),ilp(j,l)
      p(i,j,k+1)=p(i,j,k)+dp(i,j,kn)
c
c --- get new salinity from salinity integral stored in -sgain-
      if (dp(i,j,kn).gt.onecm)
     .saln(i,j,kn)=sgain(i,k)/dp(i,j,kn)
 78   continue
c
c --- water from ultra-thin layers (typically near bottom) may have repeatedly
c --- been transferred to other layers, causing dp < 0. adjust.
c
      do 79 k=kk,1,-1
      do 79 i=ifp(j,l),ilp(j,l)
      p(i,j,k)=max(0.,min(p(i,j,k),p(i,j,k+1)))
 79   dp(i,j,k+mmnn)=p(i,j,k+1)-p(i,j,k)
c
cdiag if (j.eq.jtest)
cdiag.write (lp,'(i9,2i4,'' new saln:'',11f9.4/(25x,10f9.4))')
cdiag.nstep,itest,jtest,(saln(itest,jtest,k+nn),k=1,kk)
c
      call dpudpv(p,depthu,depthv,dpu(1,1,1+mmnn),dpv(1,1,1+mmnn))
 30   continue
c
      end if                !  diapyc > 0
c
      return
      end
