      subroutine forfun
c
c --- generate monthly forcing fields
c
      include 'dimensions.h'
      include 'common_blocks.h'
c
      common/linepr/lp
c
c --- add 'biasrd' (W/m**2) to radflx to close basin heat budget
      data biasrd/9.32/
c --- add 'biaspc' (mm/30 days) to precip to close basin salinity budget
      data biaspc/-19.84/
c
      character util(idm*jdm+14)*2,preambl(5)*79
      real slim1(nbdy,jdm),slim2(nbdy,jdm)
c
      write (lp,'('' now reading forcing fields ...'')')
	idim = ii
	jdim = jj
c
c      open (unit=21,file='forcing.tau_x',status='old',readonly)
ccc      open (unit=21,file='forcing.tau_x')
c      read (21,103) preambl
c 103  format (a79)
c      write (lp,102) preambl
c 102  format (/(1x,a79))
      do 1 mo=1,12
c      read (21,100) idim,jdim,length,(util(l),l=1,length)
c 100  format (/3i6/(40a2))
c      call unpakk(util1,idm,idim,jdim,util,length)
      do 11 j=1,jdim
      do 11 i=1,idim
c 11   if (util1(i,j).gt.-999.) tauy(i,j,mo)=util1(i,j)  !  rotated grid
 11     tauy(i,j,mo)= 0.
 1    continue
c      close (unit=21)
cdiag call prtmsk(ip,tauy,util1,idm,idim,jdim,0.,100.,
cdiag.     'tau_y (.01 dynes/sq_cm) ')
c
c      open (unit=21,file='forcing.tau_y',status='old',readonly)
ccc      open (unit=21,file='forcing.tau_y')
c      read (21,103) preambl
c      write (lp,102) preambl
      do 2 mo=1,12
c      read (21,100) idim,jdim,length,(util(l),l=1,length)
c      call unpakk(util1,idm,idim,jdim,util,length)
        tmax=1.
      do 22 j=1,jdim
      do 22 i=1,idim
c 22   if (util1(i,j).gt.-999.) taux(i,j,mo)=-util1(i,j)  !  rotated grid
 22     taux(i,j,mo)= tmax*cos(pi*float(j-1)/float(jdim-1))
 2    continue
      close (unit=21)
cdiag call prtmsk(ip,taux,util1,idm,idim,jdim,0.,100.,
cdiag.     'tau_x (.01 dynes/sq_cm) ')
c
c      open (unit=21,file='forcing.windspd',status='old',readonly)
ccc      open (unit=21,file='forcing.windspd')
c      read (21,103) preambl
c      write (lp,102) preambl
      do 3 mo=1,12
c      read (21,100) idim,jdim,length,(util(l),l=1,length)
c      call unpakk(util1,idm,idim,jdim,util,length)
c --- speed is given in m/sec. convert to cm/sec
      do 33 j=1,jdim
      do 33 i=1,idim
c 33   if (util1(i,j).gt.-999.) wndspd(i,j,mo)=100.*util1(i,j)
 33   wndspd(i,j,mo)=0.
 3    continue
c      close (unit=21)
c
c      open (unit=21,file='forcing.t_star',status='old',readonly)
ccc      open (unit=21,file='forcing.t_star')
c      read (21,103) preambl
c      write (lp,102) preambl
      do 4 mo=1,12
c      read (21,100) idim,jdim,length,(util(l),l=1,length)
c      call unpakk(util1,idm,idim,jdim,util,length)
      do 44 j=1,jdim
      do 44 i=1,idim
c 44   if (util1(i,j).gt.-999.) airtmp(i,j,mo)=util1(i,j)
 44       airtmp(i,j,mo)=0.
 4    continue
c      close (unit=21)
cdiag call prtmsk(ip,airtmp,util1,idm,idim,jdim,0.,10.,
cdiag.     'air temperature  (0.1 c)')
c
c      open (unit=21,file='forcing.q_star',status='old',readonly)
ccc      open (unit=21,file='forcing.q_star')
c      read (21,103) preambl
c      write (lp,102) preambl
      do 5 mo=1,12
c      read (21,100) idim,jdim,length,(util(l),l=1,length)
c      call unpakk(util1,idm,idim,jdim,util,length)
c --- water vapor mixing ratio is given in (g/kg). convert to (g/g)
      do 55 j=1,jdim
      do 55 i=1,idim
c 55   if (util1(i,j).gt.-999.) vapmix(i,j,mo)=.001*util1(i,j)
 55   vapmix(i,j,mo)=0.
 5    continue
c      close (unit=21)
cdiag call prtmsk(ip,vapmix,util1,idm,idim,jdim,0.,10000.,
cdiag.     'mixing ratio  (0.1 g/kg)')
c
c      open (unit=21,file='forcing.precip',status='old',readonly)
ccc      open (unit=21,file='forcing.precip')
c      read (21,103) preambl
c      write (lp,102) preambl
      do 6 mo=1,12
c      read (21,100) idim,jdim,length,(util(l),l=1,length)
c      call unpakk(util1,idm,idim,jdim,util,length)
c --- convert from (mm/30 days) to (cm/sec)
      do 66 j=1,jdim
      do 66 i=1,idim
c 66   if (util1(i,j).gt.-999.) precip(i,j,mo)=(util1(i,j)+biaspc)
 66    precip(i,j,mo)=0.
 6    continue
c      close (unit=21)
cdiag call prtmsk(ip,precip,util1,idm,idim,jdim,0.,-86400.*360.,
cdiag.     'precipitation (cm/year) ')
c
c      open (unit=21,file='forcing.radflx',status='old',readonly)
ccc      open (unit=21,file='forcing.radflx')
c      read (21,103) preambl
c      write (lp,102) preambl
      do 7 mo=1,12
c      read (21,100) idim,jdim,length,(util(l),l=1,length)
c      call unpakk(util1,idm,idim,jdim,util,length)
c --- radiation is given in w/m**2. convert to w/cm**2
      do 77 j=1,jdim
      do 77 i=1,idim
c 77   if (util1(i,j).gt.-999.) radflx(i,j,mo)=(util1(i,j)+biasrd)*1.e-4
 77   radflx(i,j,mo)=0.
 7    continue
c      close (unit=21)
cdiag call prtmsk(ip,radflx,util1,idm,idim,jdim,0.,1.e4,
cdiag.     'net radiation (w/sq_m)  ')
c
c
      write (lp,'('' ...finished reading forcing fields''/)')
      return
      end
