      subroutine inicon
c
c --- version 2.6
      implicit none
c
      include 'dimensions.h'
      include 'common_blocks.h'
c
      common/linepr/lp
c
      real pinit,realat,poflat
      real psi0,psi2,xal,x1
      integer lp,imid,jmid
      external poflat
      character*24 text
c
      include 'stmt_functions.h'
c
      do 210 j=2,jj1
      do 210 l=1,isq(j)
      do 210 i=ifq(j,l),ilq(j,l)
      pbot(i  ,j  )=0.
      pbot(i-1,j  )=0.
      pbot(i  ,j-1)=0.
      pbot(i-1,j-1)=0.
      do 210 k=1,kk
      dp(i  ,j  ,k   )=0.
      dp(i  ,j  ,k+kk)=0.
      dp(i-1,j  ,k   )=0.
      dp(i-1,j  ,k+kk)=0.
      dp(i  ,j-1,k   )=0.
      dp(i  ,j-1,k+kk)=0.
      dp(i-1,j-1,k   )=0.
 210  dp(i-1,j-1,k+kk)=0.
c
c --- initialize  u,ubavg,utotm,uflx,uflux,uflux2/3,uja,ujb  at points
c --- located upstream and downstream (in i direction) of p points.
c --- initialize  depthu,dpu,utotn,pgfx  upstream and downstream of p points
c --- as well as at lateral neighbors of interior u points.
c
      do 156 j=1,jj1
      do 156 l=1,isu(j)
      ja=mod(j-2+jj,jj)+1
      jb=j+1
      do 156 i=ifu(j,l),ilu(j,l)
      pu(i,j,1)=0.
c
      depthu(i,ja)=0.
      utotn (i,ja)=0.
      pgfx  (i,ja)=0.
c
      depthu(i,jb)=0.
      utotn (i,jb)=0.
      pgfx  (i,jb)=0.
c
      do 156 k=1,kk
      dpu(i,ja,k   )=0.
      dpu(i,ja,k+kk)=0.
c
      dpu(i,jb,k   )=0.
      dpu(i,jb,k+kk)=0.
 156  continue
c
      do 158 j=1,jj1
      do 158 l=1,isp(j)
      do 158 i=ifp(j,l),ilp(j,l)+1
      depthu(i,j)=0.
      utotn (i,j)=0.
      pgfx  (i,j)=0.
      ubavg(i,j,1)=0.
      ubavg(i,j,2)=0.
      ubavg(i,j,3)=0.
      utotm (i,j)=0.
      uflux (i,j)=0.
      uflux2(i,j)=0.
      uflux3(i,j)=0.
      uja(i,j)=0.
      ujb(i,j)=0.
c
      do 158 k=1,kk
      dpu(i,j,k   )=0.
      dpu(i,j,k+kk)=0.
      uflx(i,j,k)=0.
      u(i,j,k   )=0.
 158  u(i,j,k+kk)=0.
c
c --- initialize  v,vbavg,vtotm,vflx,vflux,vflux2/3,via,vib  at points
c --- located upstream and downstream (in j direction) of p points.
c --- initialize  depthv,dpv,vtotn,pgfy  upstream and downstream of p points
c --- as well as at lateral neighbors of interior v points.
c
      do 166 i=1,ii1
      do 166 l=1,jsv(i)
      ia=mod(i-2+ii,ii)+1
      ib=i+1
      do 166 j=jfv(i,l),jlv(i,l)
      pv(i,j,1)=0.
c
      depthv(ia,j)=0.
      vtotn (ia,j)=0.
      pgfy  (ia,j)=0.
c
      depthv(ib,j)=0.
      vtotn (ib,j)=0.
      pgfy  (ib,j)=0.
c
      do 166 k=1,kk
      dpv(ia,j,k   )=0.
      dpv(ia,j,k+kk)=0.
c
      dpv(ib,j,k   )=0.
      dpv(ib,j,k+kk)=0.
 166  continue
c
      do 168 i=1,ii1
      do 168 l=1,jsp(i)
      do 168 j=jfp(i,l),jlp(i,l)+1
      depthv(i,j)=0.
      vtotn (i,j)=0.
      pgfy  (i,j)=0.
      vbavg(i,j,1)=0.
      vbavg(i,j,2)=0.
      vbavg(i,j,3)=0.
      vtotm (i,j)=0.
      vflux (i,j)=0.
      vflux2(i,j)=0.
      vflux3(i,j)=0.
      via(i,j)=0.
      vib(i,j)=0.
c
      do 168 k=1,kk
      dpv(i,j,k   )=0.
      dpv(i,j,k+kk)=0.
      vflx(i,j,k)=0.
      v(i,j,k   )=0.
 168  v(i,j,k+kk)=0.
c
c --- -------------------------
c --- mass field initialization
c --- -------------------------
c
c --- subtract base value from theta values in coordinate layers
c
      do 16 k=1,kk
 16   theta(k)=theta(k)-thbase
c
      do 10 j=1,jj1
      do 10 l=1,isp(j)
      do 10 i=ifp(j,l),ilp(j,l)
      thmix(i,j,1)=theta(1)
      thmix(i,j,2)=theta(1)
      p(i,j,1)=0.
      do 10 k=1,kk
      saln(i,j,k   )=35.0
      temp(i,j,k   )=tofsig(theta(k)+thbase,saln(i,j,k))
      temp(i,j,k+kk)=temp(i,j,k)
      saln(i,j,k+kk)=saln(i,j,k)
 10   tracer(i,j,k)=0.
c
      write (lp,'('' sigma(k):'',3p17f7.2)') (theta(k)+thbase,k=1,kk)
      write (lp,'('' temp (k):'',17f7.2)') (temp(ii/2,jj/2,k),k=1,kk)
      write (lp,'('' saln (k):'',17f7.2)') (saln(ii/2,jj/2,k),k=1,kk)
c
      do 54 k=1,kk
c
      do 67 j=1,jj1
      do 67 l=1,isp(j)
      do 67 i=ifp(j,l),ilp(j,l)
      pinit=6000.*onem
      if (rotat) then
      realat=(xpivo-xold(i,j))*grido/radian
c      else
c      realat=alat(xpivn-float(i),gridn)
      end if
c      if (k.lt.kk) pinit=poflat(.5*(theta(k)+theta(k+1))+thbase,realat)
      if (k.eq.1) p(i,j,k+1)=onem*min(200.,depths(i,j))
      if (k.eq.2) p(i,j,k+1)=onem*min(600.,depths(i,j))
      if (k.eq.3) p(i,j,k+1)=onem*min(1000.,depths(i,j))
      if (k.eq.4) p(i,j,k+1)=onem*depths(i,j)
      dp(i,j,k)=p(i,j,k+1)-p(i,j,k)
 67   dp(i,j,k+kk)=dp(i,j,k)
c
cdiag if (mod(k,3).ne.1) go to 54
cdiag write (text,'(''intf.pressure (m), k='',i3)') k+1
cdiag call prtmsk(ip,p(1,1,k+1),util1,idm,ii1,jj1,0.,1./onem,text)
c
 54   continue
c
      do 50 j=1,jj1
      do 50 l=1,isp(j)
      do 50 i=ifp(j,l),ilp(j,l)
      pbavg(i,j,1)=0.
      pbavg(i,j,2)=0.
      pbavg(i,j,3)=0.
      pbot(i,j)=p(i,j,kk+1)
c
c --- 2 (equally valid) variations on the montg.pot. initialization theme:
c
ccc      montg(i,j,kk)=0.
ccc      do 52 k=kk-1,2,-1
ccc 52   montg(i,j,k)=montg(i,j,k+1)+p(i,j,k+1)*(theta(k+1)-theta(k))*thref
ccc      montg(i,j,1)=montg(i,j,2)+p(i,j,2)*(theta(2)-thmix(i,j,1))*thref
c
      montg(i,j,1)=0.
      montg(i,j,2)=montg(i,j,1)-p(i,j,2)*(theta(2)-thmix(i,j,1))*thref
      do 52 k=2,kk-1
 52   montg(i,j,k+1)=montg(i,j,k)-p(i,j,k+1)*(theta(k+1)-theta(k))*thref
c
 50   psikk(i,j)=montg(i,j,kk)
c
c --- define water depth (bottom pressure) at  u,v,vort  points
c
      do 151 j=1,jj1
      do 151 l=1,isu(j)
      do 151 i=ifu(j,l),ilu(j,l)
      depthu(i,j)=uvdep(pbot(i,j),pbot(i-1,j))
      pvtrop(i,j  )=corio(i,j  )*2./(pbot(i,j)+pbot(i-1,j))
 151  pvtrop(i,j+1)=corio(i,j+1)*2./(pbot(i,j)+pbot(i-1,j))
c
      do 152 i=1,ii1
      do 152 l=1,jsv(i)
      do 152 j=jfv(i,l),jlv(i,l)
      depthv(i,j)=uvdep(pbot(i,j),pbot(i,j-1))
      pvtrop(i  ,j)=corio(i  ,j)*2./(pbot(i,j)+pbot(i,j-1))
 152  pvtrop(i+1,j)=corio(i+1,j)*2./(pbot(i,j)+pbot(i,j-1))
c
      do 153 j=2,jj1
      do 153 l=1,isq(j)
      do 153 i=ifq(j,l),ilq(j,l)
 153  pvtrop(i,j)=corio(i,j)*4./(pbot(i,j  )+pbot(i-1,j  )
     .                          +pbot(i,j-1)+pbot(i-1,j-1))
c
c --- define initial layer depth at  u,v  points
c
      call dpudpv(p,depthu,depthv,dpu(1,1,1   ),dpv(1,1,1   ))
      call dpudpv(p,depthu,depthv,dpu(1,1,1+kk),dpv(1,1,1+kk))
c
c      theta(1)=-thbase
c
      return
      end
