      program micom
c
c --- --------------------------------------
c --- miami isopycnic coordinate ocean model
c
c ---         v e r s i o n    2.6
c --- --------------------------------------
c
      implicit none
c
      include 'dimensions.h'
      include 'common_blocks.h'
c
      common/linepr/lp
c
      real realat,sum,coord,day1,day2,x,x1,time0,f0,beta
      integer lp,nstep0,ni,no,nop,ii2,jj2,idim,jdim,length
      character*2 util(idm*jdm+14),preambl(5)*79
      data nstep0,time0/0,0./
c
      include 'stmt_functions.h'
c
      lp=6
      write (lp,'('' turb. flux parameters:'',1p/
     .  '' thkdff,temdff,veldff ='',3e9.2/
     .  '' viscos,diapyc,vertmx ='',3e9.2)')
     .     thkdff,temdff,veldff,viscos,diapyc,vertmx
c
c --- 'lstep' = number of barotropic time steps per baroclinic time step.
c --- lstep   m u s t   be even.
c
      lstep=baclin/batrop
      lstep=2*((lstep+1)/2)
      dlt=baclin/lstep
      write (lp,'(i4,'' barotropic steps per baroclinic time step'')')
     .  lstep
c
c --- acquire basin depths
c
c --- flat bottom
c      
      do 6 j=1,jj
      do 6 i=1,ii
        depths(i,j)=5000.
        depths(i,j)=max(20.,depths(i,j))
 6    continue
c
c --- realistic array
c        
c      open (unit=9,file='depth.51x56',status='old',readonly)
c      read (9,120) preambl,idim,jdim,length,(util(l),l=1,length)
c 120  format (5(a79/),3i6/(40a2))
c      close (unit=9)
c      write (lp,'(/(1x,a79))') preambl
c      call unpakk(depths,idm,idim,jdim,util,length)
c
c --- determine do-loop limits for u,v,p,q points
      call bigrid(depths)
ccc      do 3 i=1,ii1
ccc 3    write (lp,'('' i='',i3,'' jfp,jlp='',7(1x,2i4))') i,
ccc     . (jfp(i,l),jlp(i,l),l=1,jsp(i))
ccc      do 5 j=1,jj1
ccc 5    write (lp,'('' j='',i3,'' ifp,ilp='',7(1x,2i4))') j,
ccc     . (ifp(j,l),ilp(j,l),l=1,isp(j))
c
c --- smooth bottom topography (optional)
ccc      call psmoo(depths,util1)
c
      call prtmsk(ip,depths,util1,idm,ii1,jj1,0.,1.,
     .     'bottom depth (m)')
c
c --- express vorticity points in rotated grid in terms of old (lat/lon) grid
c
      if (rotat) then
        call newold(idm,jdm,-.5)
c
        do 562 j=1,jj,jj1
        do 562 i=1,ii,ii1
 562    write (lp,126) i,j,(xpivo-xold(i,j))*grido
     .                   ,(yold(i,j)-ypivo)*grido
 126    format (' corner point',2i4,'  is at lat/lon',2f7.1,
     .  '  relative to pivot point')
      end if
c
c --- define coriolis parameter and grid size
c      
      beta = 2.e-13
c
      do 56  i=1,ii
      do 561 j=1,jj
c      if (rotat) then
c        realat=(xpivo-xold(i,j))*grido/radian
c      else
c        realat=alat(xpivn-float(i)+.5,gridn)
c      end if
c 561  corio(i,j)=sin(realat)*4.*pi/86400.
c
c --- beta plane
c
 561  corio(i,j)=.9e-4+float(j-jj1/2)*gridn*beta
c      
c --- scu,scv,scp: grid scale at  u,v,p  points respectively
c
c --- Mercator projection (gridn in degrees)
c      
c      scu(i)=111.2e5*(alat(xpivn-(i-1.),gridn)
c     .               -alat(xpivn-(i   ),gridn))*radian
c      scv(i)=111.2e5*(alat(xpivn-(i-.5),gridn)
c     .               -alat(xpivn-(i+.5),gridn))*radian
c
c --- constant grid (gridn in cm)
c      
      scu(i)=gridn
      scv(i)=gridn
      scp(i)=scv(i)
      scu2(i)=scu(i)**2
      scv2(i)=scv(i)**2
      scp2(i)=scp(i)**2
c
      scui(i)=1./scu(i)
      scvi(i)=1./scv(i)
      scpi(i)=1./scp(i)
      scu2i(i)=1./scu2(i)
      scv2i(i)=1./scv2(i)
      scp2i(i)=1./scp2(i)
 56   continue
cdiag write (lp,'('' mesh size, u points:''1p/(1x,8e9.2))') scu
cdiag write (lp,'('' mesh size, v points:''1p/(1x,8e9.2))') scv
cdiag call zebra(corio,idm,ii,jj)
cdiag write (lp,'('' shown above: coriolis parameter'')')
c
      area=0.
c
      do 57 j=1,jj1
      do 57 l=1,isp(j)
      do 57 i=ifp(j,l),ilp(j,l)
 57   area=area+scp2(i)
c
c --- set up  f o r c i n g  functions (one per month for each variable)
c
      if (rotat) call newold(idm,jdm,0.)
      call forfun
      watcum=0.
      empcum=0.
c
      call inicon
c
c --- model is to be integrated from time step 'nstep1' to 'nstep2'
      read (5,*) day1,day2,trcrin,trcout
c
      nstep1=day1*86400./baclin + .0001
      nstep2=day2*86400./baclin + .0001
c
      delt1=baclin
      if (nstep1.le.0) go to 2
      delt1=baclin+baclin
c
c --- start from restart file
c
      ni=11
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c --- option 1: read genuine binary restart file
c
      read (ni) nstep0,time0,u
      read (ni) nstep0,time0,v
      read (ni) nstep0,time0,dp
      read (ni) nstep0,time0,temp
      read (ni) nstep0,time0,saln
      read (ni) nstep0,time0,thmix,ubavg,vbavg,pbavg
      if (trcrin)
     .read (ni) nstep0,time0,tracer
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c --- option 2: concoct restart file from ascii archive file
c
ccc      open (unit=ni,file='archive.dy1800',status='old',readonly)
ccc      call restart(ni,day1)
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c
c --- diagnose pressure at p,u,v points from restart -dp- field
c
      do 16 m=1,2
      mm=(m-1)*kk
c
      do 18 j=1,jj1
      do 18 k=1,kk
      do 18 l=1,isp(j)
      do 18 i=ifp(j,l),ilp(j,l)
 18   p(i,j,k+1)=p(i,j,k)+dp(i,j,k+mm)
c
      call dpudpv(p,depthu,depthv,dpu(1,1,1+mm),dpv(1,1,1+mm))
 16   continue
c
      nstep0=time0*86400./baclin+.0001
      write (lp,111) nstep0,nstep1
 111  format (9x,'time step in restart file -',i9,5x,'wanted -',i9)
      if (nstep0.eq.nstep1) go to 2
c
c --- if restart file allows restart at a time greater than nstep1, use it
      nstep2=nstep0+nstep2-nstep1
      nstep1=nstep0
c
 2    nstep=nstep1
      write (lp,102) nstep
 102  format (/' model integration starts from time step',i9)
c
c --- ---------------------
c --- main loop starts here
c --- ---------------------
c
c --- letter 'm' refers to mid-time level (example: dp(i,j,km) )
c --- letter 'n' refers to old and new time level
c
 15   m=mod(nstep  ,2)+1
      n=mod(nstep+1,2)+1
      mm=(m-1)*kk
      nn=(n-1)*kk
      k1m=1+mm
      k1n=1+nn
c
      nstep=nstep+1
      time=time0+(nstep-nstep0)*baclin/86400.
      diagno=.false.
      if (amod(time+.0001,diagfq).lt..0002) diagno=.true.
      if (nstep.ge.nstep2) diagno=.true.
cdiag diagno=.true.
c
c --- set weights for quasi-hermite time interpolation among monthly forcing
c --- fields
      x=1.+amod(time,360.)/30.
      l1=x
      l0=mod(l1+10,12)+1
      l2=mod(l1,12)+1
      l3=mod(l2,12)+1
      x=x-float(l1)
      x1=1.-x
      w1=x1*(1.+x *(1.-1.5*x ))
      w2=x *(1.+x1*(1.-1.5*x1))
      w0=-.5*x *x1*x1
      w3=-.5*x1*x *x
cdiag write (lp,'(i9,'' time interpolation: months'',4i3,'',  weights '',
cdiag.  4f6.3)') nstep,l0,l1,l2,l3,w0,w1,w2,w3
c
c --- set weights for quasi-hermite time interpolation among seasonal (4/year)
c --- forcing fields
      x=1.+amod(time+330.,360.)/90.
      ls1=x
      ls0=mod(ls1+2,4)+1
      ls2=mod(ls1  ,4)+1
      ls3=mod(ls2,  4)+1
      x=x-float(ls1)
      x1=1.-x
      ws1=x1*(1.+x *(1.-1.5*x ))
      ws2=x *(1.+x1*(1.-1.5*x1))
      ws0=-.5*x *x1*x1
      ws3=-.5*x1*x *x
cdiag write (lp,'(i9,'' time interpolation: seasons'',4i3,
cdiag.'',  weights '',4f7.3)') nstep,ls0,ls1,ls2,ls3,ws0,ws1,ws2,ws3
c
ccc      write(6,*)'nstep=',nstep
      call cnuity(m,n,mm,nn,k1m,k1n)
c      call tsadvc(m,n,mm,nn,k1m,k1n)
      call momeq1(m,n,mm,nn,k1m,k1n)
      call momeq2(m,n,mm,nn,k1m,k1n)
      call barotp(m,n,mm,nn,k1m,k1n)
c      call convec(m,n,mm,nn,k1m,k1n)
c      call diapfl(m,n,mm,nn,k1m,k1n)
c      if (thermo)
c     .call thermf(m,n,mm,nn,k1m,k1n)
c      call mxlayr(m,n,mm,nn,k1m,k1n)
c
c ---------------------------------------------------------------------------
c
c --- output and diagnostic calculations
c
c ---------------------------------------------------------------------------
c
      if (diagno) then
        sum=0.
        do 704 j=1,jj1
        do 704 l=1,isp(j)
        do 704 i=ifp(j,l),ilp(j,l)
c --- compute sea surface height
        util1(i,j)=montg(i,j,1)+thref*pbavg(i,j,m)
 704    sum=sum+util1(i,j)*scp2(i)
        write (lp,'(i9,'' mean sea srf.hgt. (mm):'',f9.2)') nstep,
     .  sum/(area*onemm)
      end if
c
c --- diagnose meridional overturning and heat flux
c      if (mod(time+.0001,11680.).lt..0002) call overtn
c      if (nstep.ge.nstep2.and.time.lt.11680.) call overtn
c
      if (.not.diagno) go to 23
c
      write (lp,100) nstep,int((time+.001)/360.),amod(time+.001,360.)
 100  format (' time step',i9,9x,'y e a r',i6,9x,'d a y',f9.2)
c
c --- output to history file
c
      nop=13
      do 75 k=1,kk
      kn=k+nn
      coord=theta(k)+thbase
      ii2=ii-2
      jj2=jj-2
      call pakmsk(iu(2,1),u(2,1,kn),util3,idm,ii2,jj1,util,length)
      write (nop,117) ' u-vel. ',nstep,time,coord,ii2,jj1,
     .      length,(util(l),l=1,length)
      call pakmsk(iv(1,2),v(1,2,kn),util3,idm,ii1,jj2,util,length)
      write (nop,117) ' v-vel. ',nstep,time,coord,ii1,jj2,
     .      length,(util(l),l=1,length)
      call pakmsk(ip,dp(1,1,kn),util3,idm,ii1,jj1,util,length)
      write (nop,117) ' thknss ',nstep,time,coord,ii1,jj1,
     .      length,(util(l),l=1,length)
c      call pakmsk(ip,temp(1,1,kn),util3,idm,ii1,jj1,util,length)
c      write (nop,117) ' temp   ',nstep,time,coord,ii1,jj1,
c     .      length,(util(l),l=1,length)
c      call pakmsk(ip,saln(1,1,kn),util3,idm,ii1,jj1,util,length)
c      write (nop,117) ' salin  ',nstep,time,coord,ii1,jj1,
c     .      length,(util(l),l=1,length)
c      if (k.eq.1) then
c        call pakmsk(ip,thmix(1,1,n),util3,idm,ii1,jj1,util,length)
c        write (nop,117) ' th-mixl',nstep,time,coord,ii1,jj1,
c     .      length,(util(l),l=1,length)
c      else
c        call pakmsk(ip,tracer(1,1,k),util3,idm,ii1,jj1,util,length)
c        write (nop,117) ' tracer ',nstep,time,coord,ii1,jj1,
c     .      length,(util(l),l=1,length)
c      end if
 75   continue
c
      coord=0.
      call pakmsk(iu(2,1),ubavg(2,1,n),util3,idm,ii2,jj1,util,length)
      write (nop,117) ' u_btrop',nstep,time,coord,ii2,jj1,
     .      length,(util(l),l=1,length)
      call pakmsk(iv(1,2),vbavg(1,2,n),util3,idm,ii1,jj2,util,length)
      write (nop,117) ' v_btrop',nstep,time,coord,ii1,jj2,
     .      length,(util(l),l=1,length)
      call pakmsk(ip,pbavg(1,1,n),util3,idm,ii1,jj1,util,length)
      write (nop,117) ' p_btrop',nstep,time,coord,ii1,jj1,
     .      length,(util(l),l=1,length)
      call pakmsk(ip,montg,util3,idm,ii1,jj1,util,length)
      write (nop,117) ' montg_1',nstep,time,coord,ii1,jj1,
     .      length,(util(l),l=1,length)
 117  format (' ::',a8,i8,f8.1,f8.5,2i4,i6/(1x,64a2))
c
c --- output to restart file
c
      no=12
      rewind no
      write (no) nstep,time,u
      write (no) nstep,time,v
      write (no) nstep,time,dp
      write (no) nstep,time,temp
      write (no) nstep,time,saln
      write (no) nstep,time,thmix,ubavg,vbavg,pbavg
      if (trcout)
     .write (no) nstep,time,tracer
c
      write (lp,105) nstep
 105  format (' step',i9,' -- archiving completed --')
c
c --- output to line printer
c
c      call prtmsk(ip,util1,util3,idm,ii1,jj1,0.,1./onecm,
c     .     'sea surface height (cm)')
c      call prtmsk(ip,dp(1,1,k1n),util3,idm,ii1,jj1,0.,1./onem,
c     .     'mixed layer depth (m)')
c      call prtmsk(ip,temp(1,1,k1n),util3,idm,ii1,jj1,0.,10.,
c     .     'mix.layer temp. (.1 deg)')
c      call prtmsk(ip,saln(1,1,k1n),util3,idm,ii1,jj1,35.,100.,
c     .     'mx.lay. salin. (.01 mil)')
      do 77 j=1,jj1
      do 77 l=1,isu(j)
      do 77 i=ifu(j,l),ilu(j,l)
 77   util1(i,j)=u(i,j,k1n)+ubavg(i,j,n)
c      call prtmsk(iu,util1,util3,idm,ii1,jj1,0.,10.,
c     .     'u vel. (mm/s), layer 1')
      do 78 i=1,ii1
      do 78 l=1,jsv(i)
      do 78 j=jfv(i,l),jlv(i,l)
 78   util2(i,j)=v(i,j,k1n)+vbavg(i,j,n)
c      call prtmsk(iv,util2,util3,idm,ii1,jj1,0.,10.,
c     .     'v vel. (mm/s), layer 1')
ccc   call prtmsk(iu,ubavg(1,1,n),util3,idm,ii1,jj1,0.,10.,
ccc  .     'barotrop. u vel. (mm/s)')
ccc   call prtmsk(iv,vbavg(1,1,n),util3,idm,ii1,jj1,0.,10.,
ccc  .     'barotrop. v vel. (mm/s)')
c
 23   if (nstep.ge.nstep2) stop '(normal)'
      delt1=baclin+baclin
      go to 15
      end
