      SUBROUTINE ARROW(XAA,YAA,XBB,YBB)
C
C --- DRAW ARROW POINTING FROM (XAA,YAA) TO (XBB,YBB)
C --- IF ARROW IS LONGER THAN 'CUTOFF' GRID UNITS, TRUNCATE IT TO THAT
C --- LENGTH AND INDICATE ORIGINAL VECTOR LENGTH BY NUMBER OF BARBS
C --- (1 BARB IF ORIG.LENGTH LIES IN THE RANGE (1.5...2.5)*CUTOFF,
C --- 2 BARBS IF ORIG.LENGTH LIES IN THE RANGE (2.5...3.5)*CUTOFF, ETC.)
C
      DATA CUTOFF/2./,BARB/.2/,HEADSZ/.4/
      REDUC=.5*CUTOFF/AMAX1(CUTOFF,SQRT((XBB-XAA)**2+(YBB-YAA)**2))
      XA=(.5+REDUC)*XAA+(.5-REDUC)*XBB
      XB=(.5+REDUC)*XBB+(.5-REDUC)*XAA
      YA=(.5+REDUC)*YAA+(.5-REDUC)*YBB
      YB=(.5+REDUC)*YBB+(.5-REDUC)*YAA
      N=MIN1(10.,.5/REDUC-.5)
      D=0.
 1    N=N-1
      IF (N.LT.0) GO TO 2
      CALL FRSTPT(XA+D*(XB-XA)             ,YA+D*(YB-YA)             )
      CALL VECTOR(XA+D*(XB-XA)-BARB*(YB-YA),YA+D*(YB-YA)+BARB*(XB-XA))
      CALL VECTOR(XA+D*(XB-XA)             ,YA+D*(YB-YA)             )
      D=D+BARB*.5
      GO TO 1
 2    Q=SQRT((XB-XA)**2+(YB-YA)**2)
      CALL FRSTPT(XA,YA)
      CALL VECTOR(XB,YB)
      IF (Q.EQ.0.) RETURN
      Q=HEADSZ/Q
      CALL VECTOR(XB-(XB-XA-(YB-YA)*0.4)*Q,YB-(YB-YA+(XB-XA)*0.4)*Q)
      CALL VECTOR(XB-(XB-XA+(YB-YA)*0.4)*Q,YB-(YB-YA-(XB-XA)*0.4)*Q)
      CALL VECTOR(XB,YB)
      RETURN
      END
