      subroutine bordgen
c
c --- stores grid location of border points in arrays ib,jb
c
      include 'dimensions.h'
      include 'common_blocks.h'
c
      common /border/ mpts,ib(maxp),jb(maxp)
      dimension ibord(maxp),jbord(maxp),idone(maxp)
      data epsil/1.e-3/
c
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c --- declarations required for area fill:
      parameter(lgthmp=50000,lgthwk=5000)
      common /area/ map(lgthmp),xwork(lgthwk),ywork(lgthwk)
      dimension iarea(2),igrup(2)
      external shadeh
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c
c --- introduce special indices showing orientation of basin boundary
c
c --- diagonal border
      do 10 j=2,jj1
      do 10 i=2,ii1
      if (iq(i,j).eq.0) go to 10
      if (ip(i,j)+ip(i-1,j)+ip(i,j-1)+ip(i-1,j-1).ne.3) go to 10 
c --- promontory pointing NW
      if (ip(i  ,j  ).eq.0) iq(i,j)=6
c --- promontory pointing SE
      if (ip(i-1,j-1).eq.0) iq(i,j)=7
c --- promontory pointing NE
      if (ip(i  ,j-1).eq.0) iq(i,j)=8
c --- promontory pointing SW
      if (ip(i-1,j  ).eq.0) iq(i,j)=9
 10   continue
c
c --- 'left' border (j increasing to right)
      do 6 j=1,jj1
      do 6 i=2,ii1
      if (iq(i,j).ne.0) go to 6
      if (ip(i,j).gt.0.and.ip(i-1,j).gt.0) iq(i,j)=2
  6   continue
c --- 'right' border
      do 7 j=2,jj
      do 7 i=2,ii1
      if (iq(i,j).ne.0) go to 7
      if (ip(i,j-1).gt.0.and.ip(i-1,j-1).gt.0) iq(i,j)=3
  7   continue
c --- 'top' border (i increasing downward)
      do 8 j=2,jj1
      do 8 i=1,ii1
      if (iq(i,j).ne.0) go to 8
      if (ip(i,j).gt.0.and.ip(i,j-1).gt.0) iq(i,j)=4
  8   continue
c --- 'bottom' border
      do 9 j=2,jj1
      do 9 i=2,ii
      if (iq(i,j).ne.0) go to 9
      if (ip(i-1,j).gt.0.and.ip(i-1,j-1).gt.0) iq(i,j)=5
  9   continue
c
      npts=0 
      do 40 i=1,ii 
      do 40 j=1,jj 
      if (iq(i,j).le.1) go to 40 
      npts=npts+1 
      if (npts.gt.maxp) go to 100 
      ibord(npts)=i 
      jbord(npts)=j 
      idone(npts)=0 
 40   continue 
ccc      write (*,'(i7'' boundary q points''/(5(i7,i4,i3)))') npts
ccc     .,(ibord(n),jbord(n),iq(ibord(n),jbord(n)),n=1,npts)
c
      m=0
 36   landl=0
      landr=0
c --- find starting point
      m=m+1
      m1=m
      do 39 n=1,npts
      if (idone(n).eq.0) go to 42 
 39   continue
c --- all done!
      go to 37
c
c --- land on left
 43   landl=landl+1
      go to 42
c --- land on right
 44   landr=landr+1
c
 42   m=m+1 
      ib(m)=ibord(n) 
      jb(m)=jbord(n) 
      idone(n)=1 
ccc      write (*,'('' boundary point:''2i4)') ib(m),jb(m)
      iold=ib(m)
      jold=jb(m)
      iqold=iq(iold,jold)
c --- look for adjacent point in diagonal direction (scenario 1)
      do 41 n=1,npts 
      if (idone(n).eq.1) go to 41 
      inew=ibord(n)
      jnew=jbord(n)
      if (abs((inew-iold)*(jnew-jold)).ne.1) go to 41
      iqnew=iq(inew,jnew)
      if (iqold.eq.2.and.jnew.eq.jold+1) then
        if (inew.eq.iold-1.and.(iqnew.eq.4.or.iqnew.eq.7)) go to 43
        if (inew.eq.iold+1.and.(iqnew.eq.5.or.iqnew.eq.8)) go to 44
      end if
      if (iqold.eq.3.and.jnew.eq.jold-1) then
        if (inew.eq.iold-1.and.(iqnew.eq.4.or.iqnew.eq.9)) go to 44
        if (inew.eq.iold+1.and.(iqnew.eq.5.or.iqnew.eq.6)) go to 43
      end if
      if (iqold.eq.4.and.inew.eq.iold+1) then
        if (jnew.eq.jold-1.and.(iqnew.eq.2.or.iqnew.eq.7)) go to 44
        if (jnew.eq.jold+1.and.(iqnew.eq.3.or.iqnew.eq.9)) go to 43
      end if
      if (iqold.eq.5.and.inew.eq.iold-1) then
        if (jnew.eq.jold-1.and.(iqnew.eq.2.or.iqnew.eq.8)) go to 43
        if (jnew.eq.jold+1.and.(iqnew.eq.3.or.iqnew.eq.6)) go to 44
      end if
      if (iqold.eq.6) then
        if (inew.lt.iold.and.jnew.gt.jold.and.
     .     (iqnew.eq.3.or.iqnew.eq.6)) go to 44
        if (inew.gt.iold.and.jnew.lt.jold.and.
     .     (iqnew.eq.5.or.iqnew.eq.6)) go to 43
      end if
      if (iqold.eq.7) then
        if (inew.lt.iold.and.jnew.gt.jold.and.
     .     (iqnew.eq.4.or.iqnew.eq.7)) go to 43
        if (inew.gt.iold.and.jnew.lt.jold.and.
     .     (iqnew.eq.2.or.iqnew.eq.7)) go to 44
      end if
      if (iqold.eq.8) then
        if (inew.lt.iold.and.jnew.lt.jold.and.
     .     (iqnew.eq.2.or.iqnew.eq.8)) go to 43
        if (inew.gt.iold.and.jnew.gt.jold.and.
     .     (iqnew.eq.5.or.iqnew.eq.8)) go to 44
      end if
      if (iqold.eq.9) then
        if (inew.lt.iold.and.jnew.lt.jold.and.
     .     (iqnew.eq.4.or.iqnew.eq.9)) go to 44
        if (inew.gt.iold.and.jnew.gt.jold.and.
     .     (iqnew.eq.3.or.iqnew.eq.9)) go to 43
      end if
 41   continue 
c --- look for adjacent point in n-s or e-w direction (scenario 2)
      do 46 n=1,npts 
      if (idone(n).eq.1) go to 46 
      inew=ibord(n)
      jnew=jbord(n)
      if (abs(inew-iold)+abs(jnew-jold).ne.1) go to 46
      if (inew.gt.iold) then
        if (iqold.eq.2.or.iqold.eq.8) go to 44
        if (iqold.eq.3.or.iqold.eq.6) go to 43
      end if
      if (inew.lt.iold) then
        if (iqold.eq.2.or.iqold.eq.7) go to 43
        if (iqold.eq.3.or.iqold.eq.9) go to 44
      end if
      if (jnew.gt.jold) then
        if (iqold.eq.4.or.iqold.eq.9) go to 43
        if (iqold.eq.5.or.iqold.eq.6) go to 44
      end if
      if (jnew.lt.jold) then
        if (iqold.eq.4.or.iqold.eq.7) go to 44
        if (iqold.eq.5.or.iqold.eq.8) go to 43
      end if
 46   continue
c --- look for adjacent point (scenario 3 - panic)
      do 47 n=1,npts 
      if (idone(n).eq.1) go to 47
      i=ibord(n)
      j=jbord(n)
      if (iabs(i-ib(m)).le.1.and.iabs(j-jb(m)).le.1) then
      if (iq(i,j).gt.0) go to 42
      endif
 47   continue
c --- scenarios 1-3 unsuccessful. Must have gone full circle.
ccc      write (*,'('' stuck at i,j ='',2i4''. back to i,j ='',2i4)')
ccc     .   ib(m),jb(m),ib(m1+1),jb(m1+1)
      m=m+1
      ib(m)=ib(m1+1)
      jb(m)=jb(m1+1)
ccc      write (*,'('' boundary point:''2i4)') ib(m),jb(m)
      write (*,'('' bordgen --'',i9,''-pt. polygon completed'')') m-m1
      if (landl*landr.ne.0) then
        write (*,'('' error - land on  left:'',i5,'' times'')') landl
        write (*,'('' error - land on right:'',i5,'' times'')') landr
      end if
c --- store length of polygon and land/sea-side indicator in ib(m1)/jb(m1)
      ib(m1)=m-m1
      jb(m1)=sign(1,landr-landl)
c
c --- rotate coordinate system 90 degrees
      do 45 n=m1+1,m 
      ij=ib(n)
      ib(n)=jb(n)
      jb(n)=ii+1-ij
 45   continue
c
c --- look for more starting points (islands)
      go to 36
c
c --- all done!
 37   mpts=m-1
      write (*,'('' basin outline:''i7'' points'')') mpts
c
      return 
 100   write (*,
     .'('' internal array dimension exceeded in subroutine bord'')') 
      stop 
c
c
      entry bordplt
c
c --- bypass area fill?
ccc      if (1.eq.0) then
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c --- initialize area fill routine
      call arinam(map,lgthmp)
c
      m1=1
 3    m=m1+ib(m1)
      do 2 n=m1+1,m
      xwork(n-m1)=ib(n)
 2    ywork(n-m1)=jb(n)
c
c --- add polygon to 'area' map. identify land by 4, sea by 2.
      idleft=3-jb(m1)
      idrght=3+jb(m1)
ccc      write (*,'('' left/right area indicators:'',2i3,9x,
ccc     .      ''polygon sent to aredam:''/(5(f9.1,f6.1)))')
ccc     .      idleft,idrght,(xwork(n),ywork(n),n=1,m-m1)
      call aredam(map,xwork,ywork,m-m1,1,idleft,idrght)
      m1=m+1
      if (m1.lt.mpts) go to 3
      if (m.ne.mpts) write (*,'('' error -- m .ne. mpts in bord.f'')')
c
c --- add perimeter box to area map
      xwork(1)=1.-epsil
      ywork(1)=1.-epsil
      xwork(2)=float(jj)+epsil			!  rotated system
      ywork(2)=ywork(1)
      xwork(3)=xwork(2)
      ywork(3)=float(ii)+epsil			!  rotated system
      xwork(4)=xwork(1)
      ywork(4)=ywork(3)
      xwork(5)=xwork(1)
      ywork(5)=ywork(1)
      idleft=4
      idrght=2
ccc      write (*,'('' left/right area indicators:'',2i3,9x,
ccc     .      ''polygon sent to aredam:''/(5(f9.1,f6.1)))')
ccc     .      idleft,idrght,(xwork(n),ywork(n),n=1,5)
      call aredam(map,xwork,ywork,5,1,idleft,idrght)
c
c --- fill underground areas
ccc   call gsfais(1)			!  turn on solid fill
ccc   call gsfais(3)			!  turn on hatch fill
      call pikcol
      call arscam(map,xwork,ywork,lgthwk,iarea,igrup,2,shadeh)
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
ccc      end if			!  1 > 0
c
      m1=1
 4    m=m1+ib(m1)
        call frstpt(real(ib(m1+1)),real(jb(m1+1)))
      do 1 n=m1+1,m
        call vector(real(ib(n   )),real(jb(n   )))
 1    continue
      m1=m+1
      if (m1.lt.mpts) go to 4
c
      return
      end 
c
c
      subroutine shadeh(xcs,ycs,ncs,iarea,igrup,ngrups)
c
c --- this routine does the actual shading of land areas
      dimension xcs(ncs),ycs(ncs),iarea(ngrups),igrup(ngrups)
ccc      write (*,'('' shadeh: group/area='',8i3))')
ccc     .   (igrup(n),iarea(n),n=1,ngrups)
      do n=1,ngrups
c --- land index is 4
       if (igrup(n).eq.1.and.iarea(n).eq.4) then
ccc     call gsfaci(3)		!  choose color index (to go with gsfais(1))
ccc     call gsfasi(6)		!  cross-hatch option (to go with gsfais(3))
        call gfa(ncs,xcs,ycs)
       end if
      end do
      return
      end
