      subroutine getdat(yearlo,yearhi,days,time,initl)
c
c --- read model data to be plotted
c
      include 'dimensions.h'
c
      common/fields/u(idm,jdm,2*kdm),v(idm,jdm,2*kdm),dp(idm,jdm,kdm),
     .              temp(idm,jdm,2*kdm),saln(idm,jdm,2*kdm),theta(kdm),
     .              p(idm,jdm,kdm+1),thmix(idm,jdm),srfht(idm,jdm),
     .              ubaro(idm,jdm),vbaro(idm,jdm),pbaro(idm,jdm),
     .              depths(idm,jdm)
      character util(idm*jdm+14)*2,text*8,preambl(5)*79,flnm*60
      logical initl
c
c --- 'reflon' = longitude of grid point 'jref'
c --- 'gridsz' = grid size in degrees longitude
c --- 'equat'  = i index giving location of equator in grid
      data jref,reflon,equat,gridsz,lalolb/1,-97.,41.,2.,10/    ! 2 deg.mesh
ccc   data jref,reflon,equat,gridsz,lalolb/1,-97.5,96.0,.9,10/  ! .9 deg. mesh
ccc   data jref,reflon,equat,gridsz,lalolb/1,-98.,191.0,.45,5/  ! .45 deg. mesh
ccc   data jref,reflon,equat,gridsz,lalolb/1,-98.,381.0,.225,2/ ! .225 deg. mesh
ccc   data jref,reflon,equat,gridsz,lalolb/1,-98.,1071.0,.08,2/ ! .08 deg. mesh
      common/geog/jref,reflon,equat,gridsz,lalolb
      data thref/1./,ni/14/
c
c --- name of file containing the actual data is read from   s t d i n.
c
      if (initl) then
c      read (*,'(a)') flnm
c        flnm = 'fort.13_yr1to6'
	flnm = '../fort.13'
      write (*,'('' now opening data file '',a)') flnm
      open (unit=ni,file=flnm,status='old',form='formatted')
      end if				!  initl = .true.
c
      do 14 k=1,kdm
 13   read (ni,104,end=6) text,nstep,time,thet,i,j,
     .     lgth,(util(l),l=1,lgth)
 104  format (3x,a8,i8,2f8.0,2i4,i6/(1x,64a2))
      write (*,100) text(1:8),nstep,time,thet,i,j,lgth
c
      if (time.eq.0.) go to 13
      if (time.lt.yearlo*360.-.001) go to 13
      if (time.gt.yearhi*360.+.001) go to 6
c
c --- plot fields at prescribed intervals only
      if (amod(time+.001,days).gt..002) go to 13
c
      write (*,100) text(1:8),nstep,time,thet,i,j,lgth,(util(l),l=1,14)
 100  format (' ::',a8,i8,f8.1,f8.5,2i4,i6,1x,14a2)
      call unpakk(u(ii-i,1,2*k),idm,i,j,util,lgth)
c
      read (ni,104,end=6) text,nstep,time,thet,i,j,
     .     lgth,(util(l),l=1,lgth)
      write (*,100) text(1:8),nstep,time,thet,i,j,lgth,(util(l),l=1,14)
      call unpakk(v(1,jj-j,2*k),idm,i,j,util,lgth)
c
      read (ni,104,end=6) text,nstep,time,thet,i,j,
     .     lgth,(util(l),l=1,lgth)
      write (*,100) text(1:8),nstep,time,thet,i,j,lgth,(util(l),l=1,14)
      call unpakk(dp(1,1,k),idm,i,j,util,lgth)
c
c      read (ni,104,end=6) text,nstep,time,thet,i,j,
c     .     lgth,(util(l),l=1,lgth)
c      write (*,100) text(1:8),nstep,time,thet,i,j,lgth,(util(l),l=1,14)
c      call unpakk(temp(1,1,2*k),idm,i,j,util,lgth)
c
c      read (ni,104,end=6) text,nstep,time,thet,i,j,
c     .     lgth,(util(l),l=1,lgth)
c      write (*,100) text(1:8),nstep,time,thet,i,j,lgth,(util(l),l=1,14)
c      call unpakk(saln(1,1,2*k),idm,i,j,util,lgth)
c
c      read (ni,104,end=6) text,nstep,time,thet,i,j,
c     .     lgth,(util(l),l=1,lgth)
c      write (*,100) text(1:8),nstep,time,thet,i,j,lgth,(util(l),l=1,14)
c      if (k.eq.1) then
c      call unpakk(thmix,idm,i,j,util,lgth)
ccc      else
ccc      call unpakk(trac(1,1,2*k),idm,i,j,util,lgth)
c      endif
c
 14   theta(k)=thet
c
c --- now unpack barotropic velocity field
c
      read (ni,104,end=6) text,nstep,time,thet,i,j,
     .     lgth,(util(l),l=1,lgth)
      write (*,100) text(1:8),nstep,time,thet,i,j,lgth,(util(l),l=1,14)
      call unpakk(ubaro(ii-i,1),idm,i,j,util,lgth)
c
      read (ni,104,end=6) text,nstep,time,thet,i,j,
     .     lgth,(util(l),l=1,lgth)
      write (*,100) text(1:8),nstep,time,thet,i,j,lgth,(util(l),l=1,14)
      call unpakk(vbaro(1,jj-j),idm,i,j,util,lgth)
c
      read (ni,104,end=6) text,nstep,time,thet,i,j,
     .     lgth,(util(l),l=1,lgth)
      write (*,100) text(1:8),nstep,time,thet,i,j,lgth
      call unpakk(pbaro,idm,i,j,util,lgth)
c
      read (ni,104,end=6) text,nstep,time,thet,i,j,
     .     lgth,(util(l),l=1,lgth)
      write (*,100) text(1:8),nstep,time,thet,i,j,lgth
      call unpakk(srfht,idm,i,j,util,lgth)			! montg_1
c
      if (initl) then
c --- acquire basin depths
ccc      open (unit=9,file='depth.511x511',status='old',readonly)
ccc      open (unit=9,file='depth.127x127',status='old',readonly)
c      open (unit=9,file='depth.51x56',status='old',readonly)
c      read (9,'(a79)') preambl
c      write (*,'(1x,a79)') preambl
c      read (9,'(3i6/(40a2))',end=6) i,j,lgth,(util(l),l=1,lgth)
c      call unpakk(depths,idm,i,j,util,lgth)
      do 41 j=1,jj
      do 41 i=1,ii
 41   depths(i,j) = 2974.
c      close (unit=9)
      end if
c
      do 40 j=1,jj1
      do 40 i=1,ii1
 40   srfht(i,j)=(srfht(i,j)+thref*pbaro(i,j))/980.6
c
      return
c
 6    call clsgks
      stop '(e-o-f)'
      end
