      SUBROUTINE PAKK(ARRAY,IDIM,II,JJ,COMPAC,LENGTH)
C
C --- Converts the contents of -ARRAY- into an ASCII character string which
C --- is stored in character*2 array -COMPAC-. COMPAC(1)...COMPAC(7) contain
C --- the base value, i.e., the minimum value encountered in -ARRAY-.
C --- COMPAC(8)...COMPAC(14) contain a scale factor by which the individual
C --- 6-bit integers encoded as ASCII character pairs in COMPAC(8),...
C --- COMPAC(LENGTH) must be multiplied before the base value is added
C --- during an UNPAKKing operation. Base value and scale factor are encoded
C --- in E14.7 format.
C
C --- The printable ASCII characters used to encode the integers include
C --- the numbers 0...9, upper- and lower-case letters A...Z, a...z, plus
C --- two additional characters '.' and '/' (total of 64).
C
C --- A packing operation fills (II*JJ+14) array elements in -COMPAC- which
C --- must be dimensioned accordingly in the calling program. The total
C --- number of occupied array elements is returned in -LENGTH-. In calls to
C --- UNPACK, -LENGTH- is treated as input variable.
C
      real array(idim,1)
      character*2 char,compac(1),comp2(14)
      character*14 comp14(2)
      equivalence (comp2,comp14)
      data nbits/12/
      base=1.e22
      do 1 i=1,ii
      do 1 j=1,jj
 1    base=amin1(base,array(i,j))
      scal=0.
      do 2 i=1,ii
      do 2 j=1,jj
 2    scal=amax1(scal,array(i,j)-base)
      scal=scal/float(2**nbits-1)
      i1=0
      i2=0
      length=14
      do 3 i=1,ii
      do 3 j=1,jj
      if (scal.eq.0.) go to 7
      numb=(array(i,j)-base)/scal+.5
      i1=numb/64
      i2=numb-64*i1
c
c --- Map 6-bit numbers onto character set consisting of numbers
c --- 0...9, letters A...Z, a...z, and the two characters '.' and '/'.
c --- (If mapping into the character range 32...95 -- which includes the
c --- characters !"#$%&'()*+,-./:;<=>?@[\]^_  -- is deemed safe, delete
c --- the next 6 lines.)
      if (i1.gt.37) i1=i1+6
      if (i1.gt.11) i1=i1+7
      i1=i1+14
      if (i2.gt.37) i2=i2+6
      if (i2.gt.11) i2=i2+7
      i2=i2+14
c
 7    length=length+1
      compac(length)(1:1)=char(i1+32)
      compac(length)(2:2)=char(i2+32)
 100  format (a2)
 3    continue
      write (comp14(1),101) base
      write (comp14(2),101) scal
 101  format (1pe14.7)
      do 8 l=1,14
 8    compac(l)=comp2(l)
c
      return
c
c
      ENTRY UNPAKK(ARRAY,IDIM,II,JJ,COMPAC,LENGTH)
c
      do 9 l=1,14
 9    comp2(l)=compac(l)
      read (comp14(1),101) base
      read (comp14(2),101) scal
      lngth=14
      do 4 i=1,ii
      do 4 j=1,jj
      lngth=lngth+1
      i1=ichar(compac(lngth)(1:1))
      i2=ichar(compac(lngth)(2:2))
c
c --- 6-bit numbers are mapped onto character set consisting of numbers
c --- 0...9, letters A...Z, a...z, and the two characters '.' and '/'.
c --- (If mapped into character range 32...95, delete next 6 lines)
      if (i1.gt.96) i1=i1-6
      if (i1.gt.64) i1=i1-7
      i1=i1-14
      if (i2.gt.96) i2=i2-6
      if (i2.gt.64) i2=i2-7
      i2=i2-14
c
 4    array(i,j)=scal*float(64*(i1-32)+(i2-32))+base
      if (lngth.ne.length) stop 'UNPACK'
      return
      end
