      subroutine xsecij(p,idm,jdm,kdm,plotem,temp,plosal,saln,plotuv,uv
     .  ,plotth,th,iuv,kuv,ia,ib,ja,jb,depth,day,month,nquad)
c
c --- draw vertical sections in  i  or  j  direction, showing actual layer
c --- interfaces and contours of a velocity field chosen by calling program
c
c --- declarations required for area fill:
      parameter(lgthmp=50000,lgthwk=5000)
      common /area/ map(lgthmp),xwork(lgthwk),ywork(lgthwk)
      common /area1/ paint
      dimension iarea(2),igrup(2)
      logical paint
      external shadex
c
      real p(idm,jdm,kdm),uv(iuv,kuv),th(iuv,kuv)
     .    ,temp(iuv,kuv),saln(iuv,kuv)
      character text*38,label*4,month*3
      logical plotuv,plotth,plotem,plosal
      data onem/1./,siz/.21/
      common/geog/jref,reflon,equat,gridsz
      xlat(i)=2.*atan(exp(gridsz*(equat-i)/57.29578))-1.5707963268
c
      if (ia.eq.ib.and.ja.eq.jb)
     . write (*,'('' error xsecij  -- ia,ib,ja,jb =''4i4)') ia,ib,ja,jb
c
c --- four square sections per frame
ccc      xmid=.5+.24*float(2*mod(nquad,2)-1)
ccc      ymid=siz+.5*(1.-float(nquad/2))+.0001
ccc      nquad=mod(nquad+1,4)
ccc      call set(xmid-siz,xmid+siz,ymid-siz,ymid+siz,
ccc     .         float(ia+ja),float(ib+jb),0.,depth,1)
c
c --- two elongated sections per frame
      xmid=.5
      ymid=siz+.5*(1.-float(nquad/2))+.0001
      nquad=mod(nquad+2,4)
      call set(xmid-2.*siz,xmid+2.*siz,ymid-siz,ymid+siz,
     .         float(ia+ja),float(ib+jb),0.,depth,1)
c
c --- write title
c
      if (ia.eq.ib) then
        xla=57.29578*xlat(ia)
        if (xla.ge.0.) then
          write (text,103) xla,day/360.,month
 103      format ('zonal sec.'f5.1'n, year'f7.3' ('a3'.15)')
        else
          write (text,113) -xla,day/360.,month
 113      format ('zonal sec.'f5.1's, year'f7.3' ('a3'.15)')
        endif
      else if (ja.eq.jb) then
        xlo=gridsz*(ja-jref)+reflon
        if (xlo.ge.0.) then
          write (text,104) xlo,day/360.,month
 104      format ('merid.sec.'f5.1'e, year'f7.3' ('a3'.15)')
        else
          write (text,114) -xlo,day/360.,month
 114      format ('merid.sec.'f5.1'w, year'f7.3' ('a3'.15)')
        end if
      else
        write (text,100) ia,ja,ib,jb,day/360.,month
 100    format ('('i2','i2')=>('i2','i2'), year'f7.3' ('a3'.15)')
      endif
      call wtstr(.5*float(ia+ja+ib+jb),1.03*depth,text,1,0,0)
      print 101,text
 101  format (' cross section: ',a38)
c
c --- add depth labels
      call getset(xc,xd,yc,yd,xa,xb,ya,yb,dum)
      chrsiz=.008 * (xb-xa)/(xd-xc)
      factor=.5
      intvl=10.** int(       alog10(factor*depth)) * 
     .       2.**(int(3.*mod(alog10(factor*depth),1.))-1)
      do 7 l=intvl,6000,intvl
      y=depth-float(l)*onem
      if (y.le.onem) go to 7
      write (label,102) l
 102  format (i4)
      if (xmid.lt..5) then
      call wtstr(xa-chrsiz,y,label(1:4),1,0,+1)
      else
      call wtstr(xb+chrsiz,y,label(1:4),1,0,-1)
      endif
 7    continue
c
      if (.not.(plotuv.or.plotem.or.plosal.or.plotth)) go to 2
c
c --- add isolines of velocity, temperature, salinity
c
      call set(xc,xd,yc,yd,1.,float(ib-ia+jb-ja+1),1.,float(kuv),1)
      if (ib.gt.ia) l=ia
      if (jb.gt.ja) l=ja
c
      paint=.true.
      if (plotuv) then
ccc   call zebra(uv(l,1),iuv,ib-ia+jb-ja+1,kuv)
      ldash=341
      qq=10.
ccc      qq=5.
      call conrec(uv(l,1),iuv,ib-ia+jb-ja+1,kuv,-15.5*qq,15.5*qq,qq
     .   ,1,-1,-ldash)
      paint=.false.
      endif
      if (plotem) then
ccc   call zebra(temp(l,1),iuv,ib-ia+jb-ja+1,kuv)
      ldash=475
      call conrec(temp(l,1),iuv,ib-ia+jb-ja+1,kuv,0.,0.,2.,1,-1,ldash)
      paint=.false.
      endif
      if (plosal) then
ccc   call zebra(saln(l,1),iuv,ib-ia+jb-ja+1,kuv)
      ldash=495
      call conrec(saln(l,1),iuv,ib-ia+jb-ja+1,kuv,
ccc  .   .05,.95,.15,1,-1,ldash)			!  tracer
     .    32.,38.,.5,1,-1,ldash)			!  salinity
      paint=.false.
      endif
c
      if (plotth) then
      call set(xc,xd,yc,yd,1.,float(ib-ia+jb-ja+1),1.,float(kuv),1)
ccc   call zebra(th(l,1),iuv,ib-ia+jb-ja+1,kuv)
      ldash=363
      call conrec(th(l,1),iuv,ib-ia+jb-ja+1,kuv,0.,0.,.00005,1,-1,ldash)
      paint=.false.
      endif
c
c --- draw layer interfaces
c
 2    width=1.
      call gslwsc(width)
      call set(xc,xd,yc,yd,float(ia+ja),float(ib+jb),0.,depth,1)
c
      do 1 k=2,kdm+1
        ncount=1
      xnew=float(ia+ja)
      ynew=depth-p(ia,ja,k)
      if (ynew.gt.0.) call frstpt(xnew,ynew)
c
        xwork(1)=xnew
        ywork(1)=max(0.,min(depth,ynew))
c
      do 1 i=ia,ib
      do 1 j=ja,jb
      xold=xnew
      yold=ynew
      xnew=float(i+j)
      ynew=depth-p(i,j,k)
      q=-1.
      if (yold.ne.ynew) q=yold/(yold-ynew)
      if (q.ge.0..and.q.le.1.) then
c
        ncount=ncount+1
        xwork(ncount)=xold*(1.-q)+xnew*q
        ywork(ncount)=0.
c
      if (yold.gt.0.) then
      call vector(xold*(1.-q)+xnew*q,0.)
      else
      call frstpt(xold*(1.-q)+xnew*q,0.)
      call vector(xnew,ynew)
c
        ncount=ncount+1
        xwork(ncount)=xnew
        ywork(ncount)=max(0.,min(depth,ynew))
c
      endif
      else if (yold.gt.0.) then
      call vector(xnew,ynew)
c
        ncount=ncount+1
        xwork(ncount)=xnew
        ywork(ncount)=max(0.,min(depth,ynew))
c
      endif
 1    continue
      call gslwsc(1.)
c
c --- mark underground areas
c
c --- option 1: use "plus" signs to create cross-hatching effect
ccc   call set(xc,xd,yc,yd,float(ia+ja),float(ib+jb),float(kuv),1.,1)
ccc   do 3 i=ia,ib
ccc   do 3 j=ja,jb
ccc   if ((i.eq.ia.and.j.eq.ja).or.(i.eq.ib.and.j.eq.jb)) go to 3
ccc   do 4 k=2,kuv-1
ccc   if (p(i,j,kdm+1).lt.depth*float(k-1)/float(kuv-1))
ccc  .call wtstr(float(i+j),float(k),'+',1,0,0)
ccc4  continue
ccc3  continue
c
c --- option 2: draw vertical lines
ccc      do 3 i=ia,ib
ccc      do 3 j=ja,jb
cccccc      do 3 l=-1,1,2
ccc      l=0
ccc      off=.25*l
ccc      ip=max0(ia,min0(ib,i+l))
ccc      jp=max0(ja,min0(jb,j+l))
cccccc      if (i.eq.ip.and.j.eq.jp) go to 3
ccc      y=depth-(1.-abs(off))*p(i,j,kdm+1)-abs(off)*p(ip,jp,kdm+1)
ccc      if (y.le.0.) go to 3
ccc      call frstpt(float(i+j)+off,0.)
ccc      call vector(float(i+j)+off,y)
ccc 3    continue
c
c --- option 3: use area fill utility
      call arinam(map,lgthmp)
c --- add bottom pressure trace to area map
      lftrgt=sign(1,ib+jb-ia-ja)
      call aredam(map,xwork,ywork,ncount,1,3-lftrgt,3+lftrgt)
c --- add cross section perimeter to area map
      xwork(4)=xwork(ncount)
      ywork(4)=ywork(ncount)
      xwork(2)=xwork(1)
      ywork(2)=-1.e-3
      xwork(3)=xwork(4)
      ywork(3)=ywork(2)
      call aredam(map,xwork,ywork,4,1,3+lftrgt,3-lftrgt)
c --- now do the actual filling
ccc   call gsfais(1)			!  turn on solid fill
ccc   call gsfais(3)			!  turn on hatch fill
      call pikcol
      call arscam(map,xwork,ywork,lgthwk,iarea,igrup,2,shadex)
c
      call perim(1,ib-ia+jb-ja,1,1)
      return
      end
c
c
      subroutine shadex(xcs,ycs,ncs,iarea,igrup,ngrups)
c
c --- this routine does the actual shading of land areas
      dimension xcs(ncs),ycs(ncs),iarea(ngrups),igrup(ngrups)
ccc      write (*,'('' shadex: group/area='',8i3))')
ccc     .   (igrup(n),iarea(n),n=1,ngrups)
      do n=1,ngrups
c --- land index is 4
       if (igrup(n).eq.1.and.iarea(n).eq.4) then
ccc     call gsfaci(3)		!  choose color index (to go with gsfais(1))
ccc     call gsfasi(6)		!  cross-hatch option (to go with gsfais(3))
        call gfa(ncs,xcs,ycs)
       end if
      end do
      return
      end
