      subroutine restart(ni,day)
c
c --- use archive file data to create restart file look-alike
c
      include 'dimensions.h'
      include 'common_blocks.h'
c
      common/linepr/lp
c
      character util(idm*jdm+14)*2,text*8
c
c --- input archive data (unit = ni)
c
      do 14 k=1,kdm
c
 13   read (ni,104) text,nstep,time,thet,i,j,lgth,(util(l),l=1,lgth)
 104  format (3x,a8,i8,2f8.0,2i4,i6/(1x,64a2))
c
      if (time.ne.time0) then
      write (lp,111) time,day
 111  format (9x,'time step in restart file -',f9.1,5x,'wanted -',f9.1)
      time0=time
      end if
      if (time.lt.day-.001) go to 13
      if (time.gt.day+.001) stop '(e-o-f)'
c
      write (lp,100) text,nstep,time,thet,i,j,lgth,(util(l),l=1,14)
 100  format (' ::',a8,i8,f8.1,f8.5,2i4,i6,1x,14a2)
      call unpakk(u(ii-i,1,k),idm,i,j,util,lgth)
c
      read (ni,104) text,nstep,time,thet,i,j,lgth,(util(l),l=1,lgth)
      write (lp,100) text,nstep,time,thet,i,j,lgth,(util(l),l=1,14)
      call unpakk(v(1,jj-j,k),idm,i,j,util,lgth)
c
      read (ni,104) text,nstep,time,thet,i,j,lgth,(util(l),l=1,lgth)
      write (lp,100) text,nstep,time,thet,i,j,lgth,(util(l),l=1,14)
      call unpakk(dp(1,1,k),idm,i,j,util,lgth)
c
      read (ni,104) text,nstep,time,thet,i,j,lgth,(util(l),l=1,lgth)
      write (lp,100) text,nstep,time,thet,i,j,lgth,(util(l),l=1,14)
      call unpakk(temp(1,1,k),idm,i,j,util,lgth)
c
      read (ni,104) text,nstep,time,thet,i,j,lgth,(util(l),l=1,lgth)
      write (lp,100) text,nstep,time,thet,i,j,lgth,(util(l),l=1,14)
      call unpakk(saln(1,1,k),idm,i,j,util,lgth)
c
      read (ni,104) text,nstep,time,thet,i,j,lgth,(util(l),l=1,lgth)
      write (lp,100) text,nstep,time,thet,i,j,lgth,(util(l),l=1,14)
      if (k.eq.1) then
      call unpakk(thmix,idm,i,j,util,lgth)
      endif
c
 14   continue
c
 117  format (' ::',a8,i8,f8.1,f8.5,2i4,i6/(1x,64a2))
c
c --- now unpack barotropic velocity field
c
      read (ni,104) text,nstep,time,thet,i,j,lgth,(util(l),l=1,lgth)
      write (lp,100) text,nstep,time,thet,i,j,lgth,(util(l),l=1,14)
      call unpakk(ubavg(ii-i,1,1),idm,i,j,util,lgth)
c
      read (ni,104) text,nstep,time,thet,i,j,lgth,(util(l),l=1,lgth)
      write (lp,100) text,nstep,time,thet,i,j,lgth,(util(l),l=1,14)
      call unpakk(vbavg(1,jj-j,1),idm,i,j,util,lgth)
c
      read (ni,104) text,nstep,time,thet,i,j,lgth,(util(l),l=1,lgth)
      write (lp,100) text,nstep,time,thet,i,j,lgth,(util(l),l=1,14)
      call unpakk(pbavg(1,1,1),idm,i,j,util,lgth)
c
      do 151 k=1,kk
      do 151 j=1,jj1
      do 151 i=1,ii1
      p(i,j,k+1)=p(i,j,k)+dp(i,j,k)
151   continue
c
c --- define water depth (bottom pressure) at  u,v  points
c
      do 155 j=1,jj1
c
      do 152 l=1,isu(j)
      do 152 i=ifu(j,l),ilu(j,l)
152   depthu(i,j)=min(p(i,j,kk+1),p(i-1,j,kk+1))
c
      do 153 l=1,isv(j)
      do 153 i=ifv(j,l),ilv(j,l)
153   depthv(i,j)=min(p(i,j,kk+1),p(i,j-1,kk+1))
c
c --- define layer depth at  u,v  points
c
      do 155 k=1,kk
c
      do 154 l=1,isu(j)
      do 154 i=ifu(j,l),ilu(j,l)
      dpu(i,j,k)=amax1(0.,amin1(.5*(dp(i,j,k)+dp(i-1,j,k)),
     .           depthu(i,j)-.5*(p(i,j,k)+p(i-1,j,k))))
 154  dpu(i,j,k+kk)=dpu(i,j,k)
c
      do 155 l=1,isv(j)
      do 155 i=ifv(j,l),ilv(j,l)
      dpv(i,j,k)=amax1(0.,amin1(.5*(dp(i,j,k)+dp(i,j-1,k)),
     .           depthv(i,j)-.5*(p(i,j,k)+p(i,j-1,k))))
 155  dpv(i,j,k+kk)=dpv(i,j,k)
c
c --- copy variables into second time slot
c
      do k=1,kdm
      do j=1,jdm   
      do i=1,idm 
        u(i,j,k+kdm)=u(i,j,k)   
        v(i,j,k+kdm)=v(i,j,k)
        dp(i,j,k+kdm)=dp(i,j,k)
        dpu(i,j,k+kdm)=dpu(i,j,k)
        dpv(i,j,k+kdm)=dpv(i,j,k)
        temp(i,j,k+kdm)=temp(i,j,k)
        saln(i,j,k+kdm)=saln(i,j,k)
      end do
      end do 
      end do
c
      do j=1,jdm
      do i=1,idm
        thmix(i,j,2)=thmix(i,j,1)
      do n=2,3
        ubavg(i,j,n)=ubavg(i,j,1)
        vbavg(i,j,n)=vbavg(i,j,1)
        pbavg(i,j,n)=pbavg(i,j,1)
      end do
      end do
      end do
c
      return
      end

