      subroutine zebra(array,idim,ii,jj)
c
c --- find nice contour interval resulting in 7 to 10 contour lines and
c --- draw contours on line printer through the following set of grid points:
c
c         array( 1, 1) . . . . . . . . .  array( 1,jj)
c              .                               .
c              .                               .          (plot will appear
c              .                               .          on paper as shown,
c              .                               .          i down, j across)
c              .                               .
c         array(ii,jj) . . . . . . . . .  array(ii,jj)
c
c --- ii  may be smaller than  idim, the first (row) dimension of 'array'
c --- in the calling program. thus, plotting of partial arrays is possible.
c
      common/linepr/lp
c
      real array(idim,1)
      data sqrt2/1.414/
c
      amx=-1.e25
      amn= 1.e25
      do 1 i=1,ii
      do 1 j=1,jj
      amx=max(amx,array(i,j))
 1    amn=min(amn,array(i,j))
c
      if (amx.gt.amn) go to 2
      write (lp,100) array(1,1)
 100  format (//' field to be contoured is constant ...',1pe15.5/)
      return
c
 2    contur=(amx-amn)/6.
      q=10.**int(alog10(contur))
      if (contur.lt.1.) q=q/10.
      ratio=contur/q
      if (ratio.gt.sqrt2*5.)  contur=q*10.
      if (ratio.le.sqrt2*5.)  contur=q*5.
      if (ratio.le.sqrt2*2.)  contur=q*2.
      if (ratio.le.sqrt2)     contur=q
      write (lp,101) contur,amn,amx
 101  format (' contour interval in plot below is',1pe9.1,
     .        6x,'min/max =',2e11.3/)
      call digplt(array,idim,ii,jj,contur)
c
      return
      end
